SpyBara
Go Premium

Reference 2026-07-25 05:59 UTC to 2026-07-29 15:02 UTC

120 files changed +20,622 −20,017. View all changes and history on the product overview
2026
Fri 31 21:03 Thu 30 23:58 Wed 29 15:02 Thu 23 18:00 Thu 16 20:57 Tue 14 06:58 Mon 13 15:59 Sun 12 06:58 Thu 9 20:58
Details

1# Administration Overview1# Administration Overview

2 2 

3> For the complete documentation index, see [llms.txt](/llms.txt). Markdown versions of documentation pages are available by appending `.md` to the page URL.

4 

3Use the Administration API to manage organization resources such as users, invites, projects, API keys, and audit logs.5Use the Administration API to manage organization resources such as users, invites, projects, API keys, and audit logs.

4To access these endpoints, [create an Admin API key](https://platform.openai.com/settings/organization/admin-keys). Admin API keys cannot be used for non-administration endpoints.6To access these endpoints, [create an Admin API key](https://platform.openai.com/settings/organization/admin-keys). Admin API keys cannot be used for non-administration endpoints.

5 7 

Details

1# Chat Completions Overview1# Chat Completions Overview

2 2 

3> For the complete documentation index, see [llms.txt](/llms.txt). Markdown versions of documentation pages are available by appending `.md` to the page URL.

4 

3The Chat Completions API endpoint will generate a model response from a5The Chat Completions API endpoint will generate a model response from a

4list of messages comprising a conversation.6list of messages comprising a conversation.

5 7 

overview.md +2 −0

Details

1# API Overview1# API Overview

2 2 

3> For the complete documentation index, see [llms.txt](/llms.txt). Markdown versions of documentation pages are available by appending `.md` to the page URL.

4 

3Use this reference to look up OpenAI API endpoints, request and response5Use this reference to look up OpenAI API endpoints, request and response

4schemas, streaming events, client library methods, and shared behavior such as6schemas, streaming events, client library methods, and shared behavior such as

5authentication, errors, rate limits, and request IDs.7authentication, errors, rate limits, and request IDs.

Details

1# Realtime Beta Overview1# Realtime Beta Overview

2 2 

3> For the complete documentation index, see [llms.txt](/llms.txt). Markdown versions of documentation pages are available by appending `.md` to the page URL.

4 

3Communicate with a multimodal model in real time over low latency interfaces like WebRTC, WebSocket, and SIP. Natively supports speech-to-speech as well as text, image, and audio inputs and outputs.5Communicate with a multimodal model in real time over low latency interfaces like WebRTC, WebSocket, and SIP. Natively supports speech-to-speech as well as text, image, and audio inputs and outputs.

4[Learn more about the Realtime API](https://developers.openai.com/docs/guides/realtime).6[Learn more about the Realtime API](https://developers.openai.com/docs/guides/realtime).

Details

22 22 

23 - `"USD"`23 - `"USD"`

24 24 

25 The currency for the threshold amount. Currently, only `USD` is supported.

26 

27 - `"USD"`25 - `"USD"`

28 26 

29 - `enforcement: object { status }`27 - `enforcement: object { status }`


52 50 

53 - `"month"`51 - `"month"`

54 52 

55 The time interval for evaluating spend against the threshold. Currently, only `month` is supported.

56 

57 - `"month"`53 - `"month"`

58 54 

59 - `object: "project.spend_limit"`55 - `object: "project.spend_limit"`

Details

40 40 

41 - `"USD"`41 - `"USD"`

42 42 

43 The currency for the threshold amount. Currently, only `USD` is supported.

44 

45 - `"USD"`43 - `"USD"`

46 44 

47 - `enforcement: object { status }`45 - `enforcement: object { status }`


70 68 

71 - `"month"`69 - `"month"`

72 70 

73 The time interval for evaluating spend against the threshold. Currently, only `month` is supported.

74 

75 - `"month"`71 - `"month"`

76 72 

77 - `object: "project.spend_limit"`73 - `object: "project.spend_limit"`

Details

18 18 

19 - `"USD"`19 - `"USD"`

20 20 

21 The currency for the threshold amount. Currently, only `USD` is supported.

22 

23 - `"USD"`21 - `"USD"`

24 22 

25 - `enforcement: object { status }`23 - `enforcement: object { status }`


48 46 

49 - `"month"`47 - `"month"`

50 48 

51 The time interval for evaluating spend against the threshold. Currently, only `month` is supported.

52 

53 - `"month"`49 - `"month"`

54 50 

55 - `object: "organization.spend_limit"`51 - `object: "organization.spend_limit"`

Details

36 36 

37 - `"USD"`37 - `"USD"`

38 38 

39 The currency for the threshold amount. Currently, only `USD` is supported.

40 

41 - `"USD"`39 - `"USD"`

42 40 

43 - `enforcement: object { status }`41 - `enforcement: object { status }`


66 64 

67 - `"month"`65 - `"month"`

68 66 

69 The time interval for evaluating spend against the threshold. Currently, only `month` is supported.

70 

71 - `"month"`67 - `"month"`

72 68 

73 - `object: "organization.spend_limit"`69 - `object: "organization.spend_limit"`

Details

9 9 

10### Returns10### Returns

11 11 

12- `Transcription object { text, logprobs, usage }`12- `Transcription object { text, languages, logprobs, usage }`

13 13 

14 Represents a transcription response returned by model, based on the provided input.14 Represents a transcription response returned by model, based on the provided input.

15 15 


17 17 

18 The transcribed text.18 The transcribed text.

19 19 

20 - `languages: optional array of TranscriptionLanguage`

21 

22 The languages detected in the audio. Returned by `gpt-transcribe`. An empty array indicates that no language could be reliably detected.

23 

24 - `code: string`

25 

26 The code of a language detected in the audio.

27 

20 - `logprobs: optional array of object { token, bytes, logprob }`28 - `logprobs: optional array of object { token, bytes, logprob }`

21 29 

22 The log probabilities of the tokens in the transcription. Only returned with the models `gpt-4o-transcribe` and `gpt-4o-mini-transcribe` if `logprobs` is added to the `include` array.30 The log probabilities of the tokens in the transcription. Only returned with the models `gpt-4o-transcribe` and `gpt-4o-mini-transcribe` if `logprobs` is added to the `include` array.


37 45 

38 Token usage statistics for the request.46 Token usage statistics for the request.

39 47 

40 - `TokenUsage object { input_tokens, output_tokens, total_tokens, 2 more }`48 - `Tokens object { input_tokens, output_tokens, total_tokens, 2 more }`

41 49 

42 Usage statistics for models billed by token usage.50 Usage statistics for models billed by token usage.

43 51 


71 79 

72 Number of text tokens billed for this request.80 Number of text tokens billed for this request.

73 81 

74 - `DurationUsage object { seconds, type }`82 - `Duration object { seconds, type }`

75 83 

76 Usage statistics for models billed by audio input duration.84 Usage statistics for models billed by audio input duration.

77 85 


290```json298```json

291{299{

292 "text": "text",300 "text": "text",

301 "languages": [

302 {

303 "code": "code"

304 }

305 ],

293 "logprobs": [306 "logprobs": [

294 {307 {

295 "token": "token",308 "token": "token",


394}407}

395```408```

396 409 

397### Streaming

398 

399```http

400curl https://api.openai.com/v1/audio/transcriptions \

401 -H "Authorization: Bearer $OPENAI_API_KEY" \

402 -H "Content-Type: multipart/form-data" \

403 -F file="@/path/to/file/audio.mp3" \

404 -F model="gpt-4o-mini-transcribe" \

405 -F stream=true

406```

407 

408#### Response

409 

410```json

411data: {"type":"transcript.text.delta","delta":"I","logprobs":[{"token":"I","logprob":-0.00007588794,"bytes":[73]}]}

412 

413data: {"type":"transcript.text.delta","delta":" see","logprobs":[{"token":" see","logprob":-3.1281633e-7,"bytes":[32,115,101,101]}]}

414 

415data: {"type":"transcript.text.delta","delta":" skies","logprobs":[{"token":" skies","logprob":-2.3392786e-6,"bytes":[32,115,107,105,101,115]}]}

416 

417data: {"type":"transcript.text.delta","delta":" of","logprobs":[{"token":" of","logprob":-3.1281633e-7,"bytes":[32,111,102]}]}

418 

419data: {"type":"transcript.text.delta","delta":" blue","logprobs":[{"token":" blue","logprob":-1.0280384e-6,"bytes":[32,98,108,117,101]}]}

420 

421data: {"type":"transcript.text.delta","delta":" and","logprobs":[{"token":" and","logprob":-0.0005108566,"bytes":[32,97,110,100]}]}

422 

423data: {"type":"transcript.text.delta","delta":" clouds","logprobs":[{"token":" clouds","logprob":-1.9361265e-7,"bytes":[32,99,108,111,117,100,115]}]}

424 

425data: {"type":"transcript.text.delta","delta":" of","logprobs":[{"token":" of","logprob":-1.9361265e-7,"bytes":[32,111,102]}]}

426 

427data: {"type":"transcript.text.delta","delta":" white","logprobs":[{"token":" white","logprob":-7.89631e-7,"bytes":[32,119,104,105,116,101]}]}

428 

429data: {"type":"transcript.text.delta","delta":",","logprobs":[{"token":",","logprob":-0.0014890312,"bytes":[44]}]}

430 

431data: {"type":"transcript.text.delta","delta":" the","logprobs":[{"token":" the","logprob":-0.0110956915,"bytes":[32,116,104,101]}]}

432 

433data: {"type":"transcript.text.delta","delta":" bright","logprobs":[{"token":" bright","logprob":0.0,"bytes":[32,98,114,105,103,104,116]}]}

434 

435data: {"type":"transcript.text.delta","delta":" blessed","logprobs":[{"token":" blessed","logprob":-0.000045848617,"bytes":[32,98,108,101,115,115,101,100]}]}

436 

437data: {"type":"transcript.text.delta","delta":" days","logprobs":[{"token":" days","logprob":-0.000010802739,"bytes":[32,100,97,121,115]}]}

438 

439data: {"type":"transcript.text.delta","delta":",","logprobs":[{"token":",","logprob":-0.00001700133,"bytes":[44]}]}

440 

441data: {"type":"transcript.text.delta","delta":" the","logprobs":[{"token":" the","logprob":-0.0000118755715,"bytes":[32,116,104,101]}]}

442 

443data: {"type":"transcript.text.delta","delta":" dark","logprobs":[{"token":" dark","logprob":-5.5122365e-7,"bytes":[32,100,97,114,107]}]}

444 

445data: {"type":"transcript.text.delta","delta":" sacred","logprobs":[{"token":" sacred","logprob":-5.4385737e-6,"bytes":[32,115,97,99,114,101,100]}]}

446 

447data: {"type":"transcript.text.delta","delta":" nights","logprobs":[{"token":" nights","logprob":-4.00813e-6,"bytes":[32,110,105,103,104,116,115]}]}

448 

449data: {"type":"transcript.text.delta","delta":",","logprobs":[{"token":",","logprob":-0.0036910512,"bytes":[44]}]}

450 

451data: {"type":"transcript.text.delta","delta":" and","logprobs":[{"token":" and","logprob":-0.0031903093,"bytes":[32,97,110,100]}]}

452 

453data: {"type":"transcript.text.delta","delta":" I","logprobs":[{"token":" I","logprob":-1.504853e-6,"bytes":[32,73]}]}

454 

455data: {"type":"transcript.text.delta","delta":" think","logprobs":[{"token":" think","logprob":-4.3202e-7,"bytes":[32,116,104,105,110,107]}]}

456 

457data: {"type":"transcript.text.delta","delta":" to","logprobs":[{"token":" to","logprob":-1.9361265e-7,"bytes":[32,116,111]}]}

458 

459data: {"type":"transcript.text.delta","delta":" myself","logprobs":[{"token":" myself","logprob":-1.7432603e-6,"bytes":[32,109,121,115,101,108,102]}]}

460 

461data: {"type":"transcript.text.delta","delta":",","logprobs":[{"token":",","logprob":-0.29254505,"bytes":[44]}]}

462 

463data: {"type":"transcript.text.delta","delta":" what","logprobs":[{"token":" what","logprob":-0.016815351,"bytes":[32,119,104,97,116]}]}

464 

465data: {"type":"transcript.text.delta","delta":" a","logprobs":[{"token":" a","logprob":-3.1281633e-7,"bytes":[32,97]}]}

466 

467data: {"type":"transcript.text.delta","delta":" wonderful","logprobs":[{"token":" wonderful","logprob":-2.1008714e-6,"bytes":[32,119,111,110,100,101,114,102,117,108]}]}

468 

469data: {"type":"transcript.text.delta","delta":" world","logprobs":[{"token":" world","logprob":-8.180258e-6,"bytes":[32,119,111,114,108,100]}]}

470 

471data: {"type":"transcript.text.delta","delta":".","logprobs":[{"token":".","logprob":-0.014231676,"bytes":[46]}]}

472 

473data: {"type":"transcript.text.done","text":"I see skies of blue and clouds of white, the bright blessed days, the dark sacred nights, and I think to myself, what a wonderful world.","logprobs":[{"token":"I","logprob":-0.00007588794,"bytes":[73]},{"token":" see","logprob":-3.1281633e-7,"bytes":[32,115,101,101]},{"token":" skies","logprob":-2.3392786e-6,"bytes":[32,115,107,105,101,115]},{"token":" of","logprob":-3.1281633e-7,"bytes":[32,111,102]},{"token":" blue","logprob":-1.0280384e-6,"bytes":[32,98,108,117,101]},{"token":" and","logprob":-0.0005108566,"bytes":[32,97,110,100]},{"token":" clouds","logprob":-1.9361265e-7,"bytes":[32,99,108,111,117,100,115]},{"token":" of","logprob":-1.9361265e-7,"bytes":[32,111,102]},{"token":" white","logprob":-7.89631e-7,"bytes":[32,119,104,105,116,101]},{"token":",","logprob":-0.0014890312,"bytes":[44]},{"token":" the","logprob":-0.0110956915,"bytes":[32,116,104,101]},{"token":" bright","logprob":0.0,"bytes":[32,98,114,105,103,104,116]},{"token":" blessed","logprob":-0.000045848617,"bytes":[32,98,108,101,115,115,101,100]},{"token":" days","logprob":-0.000010802739,"bytes":[32,100,97,121,115]},{"token":",","logprob":-0.00001700133,"bytes":[44]},{"token":" the","logprob":-0.0000118755715,"bytes":[32,116,104,101]},{"token":" dark","logprob":-5.5122365e-7,"bytes":[32,100,97,114,107]},{"token":" sacred","logprob":-5.4385737e-6,"bytes":[32,115,97,99,114,101,100]},{"token":" nights","logprob":-4.00813e-6,"bytes":[32,110,105,103,104,116,115]},{"token":",","logprob":-0.0036910512,"bytes":[44]},{"token":" and","logprob":-0.0031903093,"bytes":[32,97,110,100]},{"token":" I","logprob":-1.504853e-6,"bytes":[32,73]},{"token":" think","logprob":-4.3202e-7,"bytes":[32,116,104,105,110,107]},{"token":" to","logprob":-1.9361265e-7,"bytes":[32,116,111]},{"token":" myself","logprob":-1.7432603e-6,"bytes":[32,109,121,115,101,108,102]},{"token":",","logprob":-0.29254505,"bytes":[44]},{"token":" what","logprob":-0.016815351,"bytes":[32,119,104,97,116]},{"token":" a","logprob":-3.1281633e-7,"bytes":[32,97]},{"token":" wonderful","logprob":-2.1008714e-6,"bytes":[32,119,111,110,100,101,114,102,117,108]},{"token":" world","logprob":-8.180258e-6,"bytes":[32,119,111,114,108,100]},{"token":".","logprob":-0.014231676,"bytes":[46]}],"usage":{"input_tokens":14,"input_token_details":{"text_tokens":0,"audio_tokens":14},"output_tokens":45,"total_tokens":59}}

474```

475 

476### Logprobs410### Logprobs

477 411 

478```http412```http


545}479}

546```480```

547 481 

548### Word timestamps482### Segment timestamps

549 483 

550```http484```http

551curl https://api.openai.com/v1/audio/transcriptions \485curl https://api.openai.com/v1/audio/transcriptions \

552 -H "Authorization: Bearer $OPENAI_API_KEY" \486 -H "Authorization: Bearer $OPENAI_API_KEY" \

553 -H "Content-Type: multipart/form-data" \487 -H "Content-Type: multipart/form-data" \

554 -F file="@/path/to/file/audio.mp3" \488 -F file="@/path/to/file/audio.mp3" \

555 -F "timestamp_granularities[]=word" \489 -F "timestamp_granularities[]=segment" \

556 -F model="whisper-1" \490 -F model="whisper-1" \

557 -F response_format="verbose_json"491 -F response_format="verbose_json"

558```492```


565 "language": "english",499 "language": "english",

566 "duration": 8.470000267028809,500 "duration": 8.470000267028809,

567 "text": "The beach was a popular spot on a hot summer day. People were swimming in the ocean, building sandcastles, and playing beach volleyball.",501 "text": "The beach was a popular spot on a hot summer day. People were swimming in the ocean, building sandcastles, and playing beach volleyball.",

568 "words": [502 "segments": [

569 {503 {

570 "word": "The",504 "id": 0,

505 "seek": 0,

571 "start": 0.0,506 "start": 0.0,

572 "end": 0.23999999463558197507 "end": 3.319999933242798,

508 "text": " The beach was a popular spot on a hot summer day.",

509 "tokens": [

510 50364, 440, 7534, 390, 257, 3743, 4008, 322, 257, 2368, 4266, 786, 13, 50530

511 ],

512 "temperature": 0.0,

513 "avg_logprob": -0.2860786020755768,

514 "compression_ratio": 1.2363636493682861,

515 "no_speech_prob": 0.00985979475080967

573 },516 },

574 ...517 ...

575 {

576 "word": "volleyball",

577 "start": 7.400000095367432,

578 "end": 7.900000095367432

579 }

580 ],518 ],

581 "usage": {519 "usage": {

582 "type": "duration",520 "type": "duration",


585}523}

586```524```

587 525 

588### Segment timestamps526### Streaming

589 527 

590```http528```http

591curl https://api.openai.com/v1/audio/transcriptions \529curl https://api.openai.com/v1/audio/transcriptions \

592 -H "Authorization: Bearer $OPENAI_API_KEY" \530 -H "Authorization: Bearer $OPENAI_API_KEY" \

593 -H "Content-Type: multipart/form-data" \531 -H "Content-Type: multipart/form-data" \

594 -F file="@/path/to/file/audio.mp3" \532 -F file="@/path/to/file/audio.mp3" \

595 -F "timestamp_granularities[]=segment" \533 -F model="gpt-4o-mini-transcribe" \

534 -F stream=true

535```

536 

537#### Response

538 

539```json

540data: {"type":"transcript.text.delta","delta":"I","logprobs":[{"token":"I","logprob":-0.00007588794,"bytes":[73]}]}

541 

542data: {"type":"transcript.text.delta","delta":" see","logprobs":[{"token":" see","logprob":-3.1281633e-7,"bytes":[32,115,101,101]}]}

543 

544data: {"type":"transcript.text.delta","delta":" skies","logprobs":[{"token":" skies","logprob":-2.3392786e-6,"bytes":[32,115,107,105,101,115]}]}

545 

546data: {"type":"transcript.text.delta","delta":" of","logprobs":[{"token":" of","logprob":-3.1281633e-7,"bytes":[32,111,102]}]}

547 

548data: {"type":"transcript.text.delta","delta":" blue","logprobs":[{"token":" blue","logprob":-1.0280384e-6,"bytes":[32,98,108,117,101]}]}

549 

550data: {"type":"transcript.text.delta","delta":" and","logprobs":[{"token":" and","logprob":-0.0005108566,"bytes":[32,97,110,100]}]}

551 

552data: {"type":"transcript.text.delta","delta":" clouds","logprobs":[{"token":" clouds","logprob":-1.9361265e-7,"bytes":[32,99,108,111,117,100,115]}]}

553 

554data: {"type":"transcript.text.delta","delta":" of","logprobs":[{"token":" of","logprob":-1.9361265e-7,"bytes":[32,111,102]}]}

555 

556data: {"type":"transcript.text.delta","delta":" white","logprobs":[{"token":" white","logprob":-7.89631e-7,"bytes":[32,119,104,105,116,101]}]}

557 

558data: {"type":"transcript.text.delta","delta":",","logprobs":[{"token":",","logprob":-0.0014890312,"bytes":[44]}]}

559 

560data: {"type":"transcript.text.delta","delta":" the","logprobs":[{"token":" the","logprob":-0.0110956915,"bytes":[32,116,104,101]}]}

561 

562data: {"type":"transcript.text.delta","delta":" bright","logprobs":[{"token":" bright","logprob":0.0,"bytes":[32,98,114,105,103,104,116]}]}

563 

564data: {"type":"transcript.text.delta","delta":" blessed","logprobs":[{"token":" blessed","logprob":-0.000045848617,"bytes":[32,98,108,101,115,115,101,100]}]}

565 

566data: {"type":"transcript.text.delta","delta":" days","logprobs":[{"token":" days","logprob":-0.000010802739,"bytes":[32,100,97,121,115]}]}

567 

568data: {"type":"transcript.text.delta","delta":",","logprobs":[{"token":",","logprob":-0.00001700133,"bytes":[44]}]}

569 

570data: {"type":"transcript.text.delta","delta":" the","logprobs":[{"token":" the","logprob":-0.0000118755715,"bytes":[32,116,104,101]}]}

571 

572data: {"type":"transcript.text.delta","delta":" dark","logprobs":[{"token":" dark","logprob":-5.5122365e-7,"bytes":[32,100,97,114,107]}]}

573 

574data: {"type":"transcript.text.delta","delta":" sacred","logprobs":[{"token":" sacred","logprob":-5.4385737e-6,"bytes":[32,115,97,99,114,101,100]}]}

575 

576data: {"type":"transcript.text.delta","delta":" nights","logprobs":[{"token":" nights","logprob":-4.00813e-6,"bytes":[32,110,105,103,104,116,115]}]}

577 

578data: {"type":"transcript.text.delta","delta":",","logprobs":[{"token":",","logprob":-0.0036910512,"bytes":[44]}]}

579 

580data: {"type":"transcript.text.delta","delta":" and","logprobs":[{"token":" and","logprob":-0.0031903093,"bytes":[32,97,110,100]}]}

581 

582data: {"type":"transcript.text.delta","delta":" I","logprobs":[{"token":" I","logprob":-1.504853e-6,"bytes":[32,73]}]}

583 

584data: {"type":"transcript.text.delta","delta":" think","logprobs":[{"token":" think","logprob":-4.3202e-7,"bytes":[32,116,104,105,110,107]}]}

585 

586data: {"type":"transcript.text.delta","delta":" to","logprobs":[{"token":" to","logprob":-1.9361265e-7,"bytes":[32,116,111]}]}

587 

588data: {"type":"transcript.text.delta","delta":" myself","logprobs":[{"token":" myself","logprob":-1.7432603e-6,"bytes":[32,109,121,115,101,108,102]}]}

589 

590data: {"type":"transcript.text.delta","delta":",","logprobs":[{"token":",","logprob":-0.29254505,"bytes":[44]}]}

591 

592data: {"type":"transcript.text.delta","delta":" what","logprobs":[{"token":" what","logprob":-0.016815351,"bytes":[32,119,104,97,116]}]}

593 

594data: {"type":"transcript.text.delta","delta":" a","logprobs":[{"token":" a","logprob":-3.1281633e-7,"bytes":[32,97]}]}

595 

596data: {"type":"transcript.text.delta","delta":" wonderful","logprobs":[{"token":" wonderful","logprob":-2.1008714e-6,"bytes":[32,119,111,110,100,101,114,102,117,108]}]}

597 

598data: {"type":"transcript.text.delta","delta":" world","logprobs":[{"token":" world","logprob":-8.180258e-6,"bytes":[32,119,111,114,108,100]}]}

599 

600data: {"type":"transcript.text.delta","delta":".","logprobs":[{"token":".","logprob":-0.014231676,"bytes":[46]}]}

601 

602data: {"type":"transcript.text.done","text":"I see skies of blue and clouds of white, the bright blessed days, the dark sacred nights, and I think to myself, what a wonderful world.","logprobs":[{"token":"I","logprob":-0.00007588794,"bytes":[73]},{"token":" see","logprob":-3.1281633e-7,"bytes":[32,115,101,101]},{"token":" skies","logprob":-2.3392786e-6,"bytes":[32,115,107,105,101,115]},{"token":" of","logprob":-3.1281633e-7,"bytes":[32,111,102]},{"token":" blue","logprob":-1.0280384e-6,"bytes":[32,98,108,117,101]},{"token":" and","logprob":-0.0005108566,"bytes":[32,97,110,100]},{"token":" clouds","logprob":-1.9361265e-7,"bytes":[32,99,108,111,117,100,115]},{"token":" of","logprob":-1.9361265e-7,"bytes":[32,111,102]},{"token":" white","logprob":-7.89631e-7,"bytes":[32,119,104,105,116,101]},{"token":",","logprob":-0.0014890312,"bytes":[44]},{"token":" the","logprob":-0.0110956915,"bytes":[32,116,104,101]},{"token":" bright","logprob":0.0,"bytes":[32,98,114,105,103,104,116]},{"token":" blessed","logprob":-0.000045848617,"bytes":[32,98,108,101,115,115,101,100]},{"token":" days","logprob":-0.000010802739,"bytes":[32,100,97,121,115]},{"token":",","logprob":-0.00001700133,"bytes":[44]},{"token":" the","logprob":-0.0000118755715,"bytes":[32,116,104,101]},{"token":" dark","logprob":-5.5122365e-7,"bytes":[32,100,97,114,107]},{"token":" sacred","logprob":-5.4385737e-6,"bytes":[32,115,97,99,114,101,100]},{"token":" nights","logprob":-4.00813e-6,"bytes":[32,110,105,103,104,116,115]},{"token":",","logprob":-0.0036910512,"bytes":[44]},{"token":" and","logprob":-0.0031903093,"bytes":[32,97,110,100]},{"token":" I","logprob":-1.504853e-6,"bytes":[32,73]},{"token":" think","logprob":-4.3202e-7,"bytes":[32,116,104,105,110,107]},{"token":" to","logprob":-1.9361265e-7,"bytes":[32,116,111]},{"token":" myself","logprob":-1.7432603e-6,"bytes":[32,109,121,115,101,108,102]},{"token":",","logprob":-0.29254505,"bytes":[44]},{"token":" what","logprob":-0.016815351,"bytes":[32,119,104,97,116]},{"token":" a","logprob":-3.1281633e-7,"bytes":[32,97]},{"token":" wonderful","logprob":-2.1008714e-6,"bytes":[32,119,111,110,100,101,114,102,117,108]},{"token":" world","logprob":-8.180258e-6,"bytes":[32,119,111,114,108,100]},{"token":".","logprob":-0.014231676,"bytes":[46]}],"usage":{"input_tokens":14,"input_token_details":{"text_tokens":0,"audio_tokens":14},"output_tokens":45,"total_tokens":59}}

603```

604 

605### Word timestamps

606 

607```http

608curl https://api.openai.com/v1/audio/transcriptions \

609 -H "Authorization: Bearer $OPENAI_API_KEY" \

610 -H "Content-Type: multipart/form-data" \

611 -F file="@/path/to/file/audio.mp3" \

612 -F "timestamp_granularities[]=word" \

596 -F model="whisper-1" \613 -F model="whisper-1" \

597 -F response_format="verbose_json"614 -F response_format="verbose_json"

598```615```


605 "language": "english",622 "language": "english",

606 "duration": 8.470000267028809,623 "duration": 8.470000267028809,

607 "text": "The beach was a popular spot on a hot summer day. People were swimming in the ocean, building sandcastles, and playing beach volleyball.",624 "text": "The beach was a popular spot on a hot summer day. People were swimming in the ocean, building sandcastles, and playing beach volleyball.",

608 "segments": [625 "words": [

609 {626 {

610 "id": 0,627 "word": "The",

611 "seek": 0,

612 "start": 0.0,628 "start": 0.0,

613 "end": 3.319999933242798,629 "end": 0.23999999463558197

614 "text": " The beach was a popular spot on a hot summer day.",

615 "tokens": [

616 50364, 440, 7534, 390, 257, 3743, 4008, 322, 257, 2368, 4266, 786, 13, 50530

617 ],

618 "temperature": 0.0,

619 "avg_logprob": -0.2860786020755768,

620 "compression_ratio": 1.2363636493682861,

621 "no_speech_prob": 0.00985979475080967

622 },630 },

623 ...631 ...

632 {

633 "word": "volleyball",

634 "start": 7.400000095367432,

635 "end": 7.900000095367432

636 }

624 ],637 ],

625 "usage": {638 "usage": {

626 "type": "duration",639 "type": "duration",

Details

250 250 

251 The chunking strategy used to chunk the file(s). If not set, will use the `auto` strategy.251 The chunking strategy used to chunk the file(s). If not set, will use the `auto` strategy.

252 252 

253 - `AutoChunkingStrategy object { type }`253 - `Auto object { type }`

254 254 

255 The default strategy. This strategy currently uses a `max_chunk_size_tokens` of `800` and `chunk_overlap_tokens` of `400`.255 The default strategy. This strategy currently uses a `max_chunk_size_tokens` of `800` and `chunk_overlap_tokens` of `400`.

256 256 


260 260 

261 - `"auto"`261 - `"auto"`

262 262 

263 - `StaticChunkingStrategy object { static, type }`263 - `Static object { static, type }`

264 264 

265 - `static: object { chunk_overlap_tokens, max_chunk_size_tokens }`265 - `static: object { chunk_overlap_tokens, max_chunk_size_tokens }`

266 266 

Details

6the `background` parameter set to `true` can be cancelled.6the `background` parameter set to `true` can be cancelled.

7[Learn more](/docs/guides/background).7[Learn more](/docs/guides/background).

8 8 

9### Path Parameters

10 

11- `response_id: string`

12 

13### Header Parameters9### Header Parameters

14 10 

15- `"openai-beta": optional array of "responses_multi_agent=v1"`11- `"openai-beta": optional array of "responses_multi_agent=v1"`

16 12 

17 - `"responses_multi_agent=v1"`13 - `"responses_multi_agent=v1"`

18 14 

15### Path Parameters

16 

17- `response_id: string`

18 

19### Returns19### Returns

20 20 

21- `BetaResponse object { id, created_at, error, 32 more }`21- `BetaResponse object { id, created_at, error, 32 more }`

Details

17629}17629}

17630```17630```

17631 17631 

17632### Text input17632### File input

17633 17633 

17634```http17634```http

17635curl https://api.openai.com/v1/responses \17635curl https://api.openai.com/v1/responses \


17637 -H "Authorization: Bearer $OPENAI_API_KEY" \17637 -H "Authorization: Bearer $OPENAI_API_KEY" \

17638 -d '{17638 -d '{

17639 "model": "gpt-5.4",17639 "model": "gpt-5.4",

17640 "input": "Tell me a three sentence bedtime story about a unicorn."17640 "input": [

17641 {

17642 "role": "user",

17643 "content": [

17644 {"type": "input_text", "text": "what is in this file?"},

17645 {

17646 "type": "input_file",

17647 "file_url": "https://www.berkshirehathaway.com/letters/2024ltr.pdf",

17648 "detail": "auto"

17649 }

17650 ]

17651 }

17652 ]

17641 }'17653 }'

17642```17654```

17643 17655 


17645 17657 

17646```json17658```json

17647{17659{

17648 "id": "resp_67ccd2bed1ec8190b14f964abc0542670bb6a6b452d3795b",17660 "id": "resp_686eef60237881a2bd1180bb8b13de430e34c516d176ff86",

17649 "object": "response",17661 "object": "response",

17650 "created_at": 1741476542,17662 "created_at": 1752100704,

17651 "status": "completed",17663 "status": "completed",

17652 "completed_at": 1741476543,17664 "completed_at": 1752100705,

17665 "background": false,

17653 "error": null,17666 "error": null,

17654 "incomplete_details": null,17667 "incomplete_details": null,

17655 "instructions": null,17668 "instructions": null,

17656 "max_output_tokens": null,17669 "max_output_tokens": null,

17670 "max_tool_calls": null,

17657 "model": "gpt-5.4",17671 "model": "gpt-5.4",

17658 "output": [17672 "output": [

17659 {17673 {

17674 "id": "msg_686eef60d3e081a29283bdcbc4322fd90e34c516d176ff86",

17660 "type": "message",17675 "type": "message",

17661 "id": "msg_67ccd2bf17f0819081ff3bb2cf6508e60bb6a6b452d3795b",

17662 "status": "completed",17676 "status": "completed",

17663 "role": "assistant",

17664 "content": [17677 "content": [

17665 {17678 {

17666 "type": "output_text",17679 "type": "output_text",

17667 "text": "In a peaceful grove beneath a silver moon, a unicorn named Lumina discovered a hidden pool that reflected the stars. As she dipped her horn into the water, the pool began to shimmer, revealing a pathway to a magical realm of endless night skies. Filled with wonder, Lumina whispered a wish for all who dream to find their own hidden magic, and as she glanced back, her hoofprints sparkled like stardust.",17680 "annotations": [],

17668 "annotations": []17681 "logprobs": [],

17682 "text": "The file seems to contain excerpts from a letter to the shareholders of Berkshire Hathaway Inc., likely written by Warren Buffett. It covers several topics:\n\n1. **Communication Philosophy**: Buffett emphasizes the importance of transparency and candidness in reporting mistakes and successes to shareholders.\n\n2. **Mistakes and Learnings**: The letter acknowledges past mistakes in business assessments and management hires, highlighting the importance of correcting errors promptly.\n\n3. **CEO Succession**: Mention of Greg Abel stepping in as the new CEO and continuing the tradition of honest communication.\n\n4. **Pete Liegl Story**: A detailed account of acquiring Forest River and the relationship with its founder, highlighting trust and effective business decisions.\n\n5. **2024 Performance**: Overview of business performance, particularly in insurance and investment activities, with a focus on GEICO's improvement.\n\n6. **Tax Contributions**: Discussion of significant tax payments to the U.S. Treasury, credited to shareholders' reinvestments.\n\n7. **Investment Strategy**: A breakdown of Berkshire\u2019s investments in both controlled subsidiaries and marketable equities, along with a focus on long-term holding strategies.\n\n8. **American Capitalism**: Reflections on America\u2019s economic development and Berkshire\u2019s role within it.\n\n9. **Property-Casualty Insurance**: Insights into the P/C insurance business model and its challenges and benefits.\n\n10. **Japanese Investments**: Information about Berkshire\u2019s investments in Japanese companies and future plans.\n\n11. **Annual Meeting**: Details about the upcoming annual gathering in Omaha, including schedule changes and new book releases.\n\n12. **Personal Anecdotes**: Light-hearted stories about family and interactions, conveying Buffett's personable approach.\n\n13. **Financial Performance Data**: Tables comparing Berkshire\u2019s annual performance to the S&P 500, showing impressive long-term gains.\n\nOverall, the letter reinforces Berkshire Hathaway's commitment to transparency, investment in both its businesses and the wider economy, and emphasizes strong leadership and prudent financial management."

17669 }17683 }

17670 ]17684 ],

17685 "role": "assistant"

17671 }17686 }

17672 ],17687 ],

17673 "parallel_tool_calls": true,17688 "parallel_tool_calls": true,


17676 "effort": null,17691 "effort": null,

17677 "summary": null17692 "summary": null

17678 },17693 },

17694 "service_tier": "default",

17679 "store": true,17695 "store": true,

17680 "temperature": 1.0,17696 "temperature": 1.0,

17681 "text": {17697 "text": {


17685 },17701 },

17686 "tool_choice": "auto",17702 "tool_choice": "auto",

17687 "tools": [],17703 "tools": [],

17704 "top_logprobs": 0,

17688 "top_p": 1.0,17705 "top_p": 1.0,

17689 "truncation": "disabled",17706 "truncation": "disabled",

17690 "usage": {17707 "usage": {

17691 "input_tokens": 36,17708 "input_tokens": 8438,

17692 "input_tokens_details": {17709 "input_tokens_details": {

17693 "cached_tokens": 0,17710 "cached_tokens": 0,

17694 "cache_write_tokens": 017711 "cache_write_tokens": 0

17695 },17712 },

17696 "output_tokens": 87,17713 "output_tokens": 398,

17697 "output_tokens_details": {17714 "output_tokens_details": {

17698 "reasoning_tokens": 017715 "reasoning_tokens": 0

17699 },17716 },

17700 "total_tokens": 12317717 "total_tokens": 8836

17701 },17718 },

17702 "user": null,17719 "user": null,

17703 "metadata": {}17720 "metadata": {}

17704}17721}

17705```17722```

17706 17723 

17707### Image input17724### File search

17708 17725 

17709```http17726```http

17710curl https://api.openai.com/v1/responses \17727curl https://api.openai.com/v1/responses \


17712 -H "Authorization: Bearer $OPENAI_API_KEY" \17729 -H "Authorization: Bearer $OPENAI_API_KEY" \

17713 -d '{17730 -d '{

17714 "model": "gpt-5.4",17731 "model": "gpt-5.4",

17715 "input": [17732 "tools": [{

17716 {17733 "type": "file_search",

17717 "role": "user",17734 "vector_store_ids": ["vs_1234567890"],

17718 "content": [17735 "max_num_results": 20

17719 {"type": "input_text", "text": "what is in this image?"},17736 }],

17720 {17737 "input": "What are the attributes of an ancient brown dragon?"

17721 "type": "input_image",

17722 "image_url": "https://upload.wikimedia.org/wikipedia/commons/thumb/d/dd/Gfp-wisconsin-madison-the-nature-boardwalk.jpg/2560px-Gfp-wisconsin-madison-the-nature-boardwalk.jpg"

17723 }

17724 ]

17725 }

17726 ]

17727 }'17738 }'

17728```17739```

17729 17740 


17731 17742 

17732```json17743```json

17733{17744{

17734 "id": "resp_67ccd3a9da748190baa7f1570fe91ac604becb25c45c1d41",17745 "id": "resp_67ccf4c55fc48190b71bd0463ad3306d09504fb6872380d7",

17735 "object": "response",17746 "object": "response",

17736 "created_at": 1741476777,17747 "created_at": 1741485253,

17737 "status": "completed",17748 "status": "completed",

17738 "completed_at": 1741476778,17749 "completed_at": 1741485254,

17739 "error": null,17750 "error": null,

17740 "incomplete_details": null,17751 "incomplete_details": null,

17741 "instructions": null,17752 "instructions": null,

17742 "max_output_tokens": null,17753 "max_output_tokens": null,

17743 "model": "gpt-5.4",17754 "model": "gpt-5.4",

17744 "output": [17755 "output": [

17756 {

17757 "type": "file_search_call",

17758 "id": "fs_67ccf4c63cd08190887ef6464ba5681609504fb6872380d7",

17759 "status": "completed",

17760 "queries": [

17761 "attributes of an ancient brown dragon"

17762 ],

17763 "results": null

17764 },

17745 {17765 {

17746 "type": "message",17766 "type": "message",

17747 "id": "msg_67ccd3acc8d48190a77525dc6de64b4104becb25c45c1d41",17767 "id": "msg_67ccf4c93e5c81909d595b369351a9d309504fb6872380d7",

17748 "status": "completed",17768 "status": "completed",

17749 "role": "assistant",17769 "role": "assistant",

17750 "content": [17770 "content": [

17751 {17771 {

17752 "type": "output_text",17772 "type": "output_text",

17753 "text": "The image depicts a scenic landscape with a wooden boardwalk or pathway leading through lush, green grass under a blue sky with some clouds. The setting suggests a peaceful natural area, possibly a park or nature reserve. There are trees and shrubs in the background.",17773 "text": "The attributes of an ancient brown dragon include...",

17754 "annotations": []17774 "annotations": [

17775 {

17776 "type": "file_citation",

17777 "index": 320,

17778 "file_id": "file-4wDz5b167pAf72nx1h9eiN",

17779 "filename": "dragons.pdf"

17780 },

17781 {

17782 "type": "file_citation",

17783 "index": 576,

17784 "file_id": "file-4wDz5b167pAf72nx1h9eiN",

17785 "filename": "dragons.pdf"

17786 },

17787 {

17788 "type": "file_citation",

17789 "index": 815,

17790 "file_id": "file-4wDz5b167pAf72nx1h9eiN",

17791 "filename": "dragons.pdf"

17792 },

17793 {

17794 "type": "file_citation",

17795 "index": 815,

17796 "file_id": "file-4wDz5b167pAf72nx1h9eiN",

17797 "filename": "dragons.pdf"

17798 },

17799 {

17800 "type": "file_citation",

17801 "index": 1030,

17802 "file_id": "file-4wDz5b167pAf72nx1h9eiN",

17803 "filename": "dragons.pdf"

17804 },

17805 {

17806 "type": "file_citation",

17807 "index": 1030,

17808 "file_id": "file-4wDz5b167pAf72nx1h9eiN",

17809 "filename": "dragons.pdf"

17810 },

17811 {

17812 "type": "file_citation",

17813 "index": 1156,

17814 "file_id": "file-4wDz5b167pAf72nx1h9eiN",

17815 "filename": "dragons.pdf"

17816 },

17817 {

17818 "type": "file_citation",

17819 "index": 1225,

17820 "file_id": "file-4wDz5b167pAf72nx1h9eiN",

17821 "filename": "dragons.pdf"

17822 }

17823 ]

17755 }17824 }

17756 ]17825 ]

17757 }17826 }


17770 }17839 }

17771 },17840 },

17772 "tool_choice": "auto",17841 "tool_choice": "auto",

17773 "tools": [],17842 "tools": [

17843 {

17844 "type": "file_search",

17845 "filters": null,

17846 "max_num_results": 20,

17847 "ranking_options": {

17848 "ranker": "auto",

17849 "score_threshold": 0.0

17850 },

17851 "vector_store_ids": [

17852 "vs_1234567890"

17853 ]

17854 }

17855 ],

17774 "top_p": 1.0,17856 "top_p": 1.0,

17775 "truncation": "disabled",17857 "truncation": "disabled",

17776 "usage": {17858 "usage": {

17777 "input_tokens": 328,17859 "input_tokens": 18307,

17778 "input_tokens_details": {17860 "input_tokens_details": {

17779 "cached_tokens": 0,17861 "cached_tokens": 0,

17780 "cache_write_tokens": 017862 "cache_write_tokens": 0

17781 },17863 },

17782 "output_tokens": 52,17864 "output_tokens": 348,

17783 "output_tokens_details": {17865 "output_tokens_details": {

17784 "reasoning_tokens": 017866 "reasoning_tokens": 0

17785 },17867 },

17786 "total_tokens": 38017868 "total_tokens": 18655

17787 },17869 },

17788 "user": null,17870 "user": null,

17789 "metadata": {}17871 "metadata": {}

17790}17872}

17791```17873```

17792 17874 

17793### File input17875### Functions

17794 17876 

17795```http17877```http

17796curl https://api.openai.com/v1/responses \17878curl https://api.openai.com/v1/responses \


17798 -H "Authorization: Bearer $OPENAI_API_KEY" \17880 -H "Authorization: Bearer $OPENAI_API_KEY" \

17799 -d '{17881 -d '{

17800 "model": "gpt-5.4",17882 "model": "gpt-5.4",

17801 "input": [17883 "input": "What is the weather like in Boston today?",

17802 {17884 "tools": [

17803 "role": "user",

17804 "content": [

17805 {"type": "input_text", "text": "what is in this file?"},

17806 {17885 {

17807 "type": "input_file",17886 "type": "function",

17808 "file_url": "https://www.berkshirehathaway.com/letters/2024ltr.pdf",17887 "name": "get_current_weather",

17809 "detail": "auto"17888 "description": "Get the current weather in a given location",

17889 "parameters": {

17890 "type": "object",

17891 "properties": {

17892 "location": {

17893 "type": "string",

17894 "description": "The city and state, e.g. San Francisco, CA"

17895 },

17896 "unit": {

17897 "type": "string",

17898 "enum": ["celsius", "fahrenheit"]

17810 }17899 }

17811 ]17900 },

17901 "required": ["location", "unit"]

17812 }17902 }

17813 ]17903 }

17904 ],

17905 "tool_choice": "auto"

17814 }'17906 }'

17815```17907```

17816 17908 


17818 17910 

17819```json17911```json

17820{17912{

17821 "id": "resp_686eef60237881a2bd1180bb8b13de430e34c516d176ff86",17913 "id": "resp_67ca09c5efe0819096d0511c92b8c890096610f474011cc0",

17822 "object": "response",17914 "object": "response",

17823 "created_at": 1752100704,17915 "created_at": 1741294021,

17824 "status": "completed",17916 "status": "completed",

17825 "completed_at": 1752100705,17917 "completed_at": 1741294022,

17826 "background": false,

17827 "error": null,17918 "error": null,

17828 "incomplete_details": null,17919 "incomplete_details": null,

17829 "instructions": null,17920 "instructions": null,

17830 "max_output_tokens": null,17921 "max_output_tokens": null,

17831 "max_tool_calls": null,

17832 "model": "gpt-5.4",17922 "model": "gpt-5.4",

17833 "output": [17923 "output": [

17834 {17924 {

17835 "id": "msg_686eef60d3e081a29283bdcbc4322fd90e34c516d176ff86",17925 "type": "function_call",

17836 "type": "message",17926 "id": "fc_67ca09c6bedc8190a7abfec07b1a1332096610f474011cc0",

17837 "status": "completed",17927 "call_id": "call_unLAR8MvFNptuiZK6K6HCy5k",

17838 "content": [17928 "name": "get_current_weather",

17839 {17929 "arguments": "{\"location\":\"Boston, MA\",\"unit\":\"celsius\"}",

17840 "type": "output_text",17930 "status": "completed"

17841 "annotations": [],

17842 "logprobs": [],

17843 "text": "The file seems to contain excerpts from a letter to the shareholders of Berkshire Hathaway Inc., likely written by Warren Buffett. It covers several topics:\n\n1. **Communication Philosophy**: Buffett emphasizes the importance of transparency and candidness in reporting mistakes and successes to shareholders.\n\n2. **Mistakes and Learnings**: The letter acknowledges past mistakes in business assessments and management hires, highlighting the importance of correcting errors promptly.\n\n3. **CEO Succession**: Mention of Greg Abel stepping in as the new CEO and continuing the tradition of honest communication.\n\n4. **Pete Liegl Story**: A detailed account of acquiring Forest River and the relationship with its founder, highlighting trust and effective business decisions.\n\n5. **2024 Performance**: Overview of business performance, particularly in insurance and investment activities, with a focus on GEICO's improvement.\n\n6. **Tax Contributions**: Discussion of significant tax payments to the U.S. Treasury, credited to shareholders' reinvestments.\n\n7. **Investment Strategy**: A breakdown of Berkshire\u2019s investments in both controlled subsidiaries and marketable equities, along with a focus on long-term holding strategies.\n\n8. **American Capitalism**: Reflections on America\u2019s economic development and Berkshire\u2019s role within it.\n\n9. **Property-Casualty Insurance**: Insights into the P/C insurance business model and its challenges and benefits.\n\n10. **Japanese Investments**: Information about Berkshire\u2019s investments in Japanese companies and future plans.\n\n11. **Annual Meeting**: Details about the upcoming annual gathering in Omaha, including schedule changes and new book releases.\n\n12. **Personal Anecdotes**: Light-hearted stories about family and interactions, conveying Buffett's personable approach.\n\n13. **Financial Performance Data**: Tables comparing Berkshire\u2019s annual performance to the S&P 500, showing impressive long-term gains.\n\nOverall, the letter reinforces Berkshire Hathaway's commitment to transparency, investment in both its businesses and the wider economy, and emphasizes strong leadership and prudent financial management."

17844 }

17845 ],

17846 "role": "assistant"

17847 }17931 }

17848 ],17932 ],

17849 "parallel_tool_calls": true,17933 "parallel_tool_calls": true,


17852 "effort": null,17936 "effort": null,

17853 "summary": null17937 "summary": null

17854 },17938 },

17855 "service_tier": "default",

17856 "store": true,17939 "store": true,

17857 "temperature": 1.0,17940 "temperature": 1.0,

17858 "text": {17941 "text": {


17861 }17944 }

17862 },17945 },

17863 "tool_choice": "auto",17946 "tool_choice": "auto",

17864 "tools": [],17947 "tools": [

17865 "top_logprobs": 0,17948 {

17949 "type": "function",

17950 "description": "Get the current weather in a given location",

17951 "name": "get_current_weather",

17952 "parameters": {

17953 "type": "object",

17954 "properties": {

17955 "location": {

17956 "type": "string",

17957 "description": "The city and state, e.g. San Francisco, CA"

17958 },

17959 "unit": {

17960 "type": "string",

17961 "enum": [

17962 "celsius",

17963 "fahrenheit"

17964 ]

17965 }

17966 },

17967 "required": [

17968 "location",

17969 "unit"

17970 ]

17971 },

17972 "strict": true

17973 }

17974 ],

17866 "top_p": 1.0,17975 "top_p": 1.0,

17867 "truncation": "disabled",17976 "truncation": "disabled",

17868 "usage": {17977 "usage": {

17869 "input_tokens": 8438,17978 "input_tokens": 291,

17870 "input_tokens_details": {17979 "output_tokens": 23,

17871 "cached_tokens": 0,

17872 "cache_write_tokens": 0

17873 },

17874 "output_tokens": 398,

17875 "output_tokens_details": {17980 "output_tokens_details": {

17876 "reasoning_tokens": 017981 "reasoning_tokens": 0

17877 },17982 },

17878 "total_tokens": 883617983 "total_tokens": 314

17879 },17984 },

17880 "user": null,17985 "user": null,

17881 "metadata": {}17986 "metadata": {}

17882}17987}

17883```17988```

17884 17989 

17885### Web search17990### Image input

17886 17991 

17887```http17992```http

17888curl https://api.openai.com/v1/responses \17993curl https://api.openai.com/v1/responses \


17890 -H "Authorization: Bearer $OPENAI_API_KEY" \17995 -H "Authorization: Bearer $OPENAI_API_KEY" \

17891 -d '{17996 -d '{

17892 "model": "gpt-5.4",17997 "model": "gpt-5.4",

17893 "tools": [{ "type": "web_search_preview" }],17998 "input": [

17894 "input": "What was a positive news story from today?"17999 {

18000 "role": "user",

18001 "content": [

18002 {"type": "input_text", "text": "what is in this image?"},

18003 {

18004 "type": "input_image",

18005 "image_url": "https://upload.wikimedia.org/wikipedia/commons/thumb/d/dd/Gfp-wisconsin-madison-the-nature-boardwalk.jpg/2560px-Gfp-wisconsin-madison-the-nature-boardwalk.jpg"

18006 }

18007 ]

18008 }

18009 ]

17895 }'18010 }'

17896```18011```

17897 18012 


17899 18014 

17900```json18015```json

17901{18016{

17902 "id": "resp_67ccf18ef5fc8190b16dbee19bc54e5f087bb177ab789d5c",18017 "id": "resp_67ccd3a9da748190baa7f1570fe91ac604becb25c45c1d41",

17903 "object": "response",18018 "object": "response",

17904 "created_at": 1741484430,18019 "created_at": 1741476777,

17905 "status": "completed",18020 "status": "completed",

17906 "completed_at": 1741484431,18021 "completed_at": 1741476778,

17907 "error": null,18022 "error": null,

17908 "incomplete_details": null,18023 "incomplete_details": null,

17909 "instructions": null,18024 "instructions": null,

17910 "max_output_tokens": null,18025 "max_output_tokens": null,

17911 "model": "gpt-5.4",18026 "model": "gpt-5.4",

17912 "output": [18027 "output": [

17913 {

17914 "type": "web_search_call",

17915 "id": "ws_67ccf18f64008190a39b619f4c8455ef087bb177ab789d5c",

17916 "status": "completed"

17917 },

17918 {18028 {

17919 "type": "message",18029 "type": "message",

17920 "id": "msg_67ccf190ca3881909d433c50b1f6357e087bb177ab789d5c",18030 "id": "msg_67ccd3acc8d48190a77525dc6de64b4104becb25c45c1d41",

17921 "status": "completed",18031 "status": "completed",

17922 "role": "assistant",18032 "role": "assistant",

17923 "content": [18033 "content": [

17924 {18034 {

17925 "type": "output_text",18035 "type": "output_text",

17926 "text": "As of today, March 9, 2025, one notable positive news story...",18036 "text": "The image depicts a scenic landscape with a wooden boardwalk or pathway leading through lush, green grass under a blue sky with some clouds. The setting suggests a peaceful natural area, possibly a park or nature reserve. There are trees and shrubs in the background.",

17927 "annotations": [18037 "annotations": []

17928 {

17929 "type": "url_citation",

17930 "start_index": 442,

17931 "end_index": 557,

17932 "url": "https://.../?utm_source=chatgpt.com",

17933 "title": "..."

17934 },

17935 {

17936 "type": "url_citation",

17937 "start_index": 962,

17938 "end_index": 1077,

17939 "url": "https://.../?utm_source=chatgpt.com",

17940 "title": "..."

17941 },

17942 {

17943 "type": "url_citation",

17944 "start_index": 1336,

17945 "end_index": 1451,

17946 "url": "https://.../?utm_source=chatgpt.com",

17947 "title": "..."

17948 }

17949 ]

17950 }18038 }

17951 ]18039 ]

17952 }18040 }


17965 }18053 }

17966 },18054 },

17967 "tool_choice": "auto",18055 "tool_choice": "auto",

17968 "tools": [18056 "tools": [],

17969 {

17970 "type": "web_search_preview",

17971 "domains": [],

17972 "search_context_size": "medium",

17973 "user_location": {

17974 "type": "approximate",

17975 "city": null,

17976 "country": "US",

17977 "region": null,

17978 "timezone": null

17979 }

17980 }

17981 ],

17982 "top_p": 1.0,18057 "top_p": 1.0,

17983 "truncation": "disabled",18058 "truncation": "disabled",

17984 "usage": {18059 "usage": {


17987 "cached_tokens": 0,18062 "cached_tokens": 0,

17988 "cache_write_tokens": 018063 "cache_write_tokens": 0

17989 },18064 },

17990 "output_tokens": 356,18065 "output_tokens": 52,

17991 "output_tokens_details": {18066 "output_tokens_details": {

17992 "reasoning_tokens": 018067 "reasoning_tokens": 0

17993 },18068 },

17994 "total_tokens": 68418069 "total_tokens": 380

17995 },18070 },

17996 "user": null,18071 "user": null,

17997 "metadata": {}18072 "metadata": {}

17998}18073}

17999```18074```

18000 18075 

18001### File search18076### Reasoning

18002 18077 

18003```http18078```http

18004curl https://api.openai.com/v1/responses \18079curl https://api.openai.com/v1/responses \

18005 -H "Content-Type: application/json" \18080 -H "Content-Type: application/json" \

18006 -H "Authorization: Bearer $OPENAI_API_KEY" \18081 -H "Authorization: Bearer $OPENAI_API_KEY" \

18007 -d '{18082 -d '{

18008 "model": "gpt-5.4",18083 "model": "o3-mini",

18009 "tools": [{18084 "input": "How much wood would a woodchuck chuck?",

18010 "type": "file_search",18085 "reasoning": {

18011 "vector_store_ids": ["vs_1234567890"],18086 "effort": "high"

18012 "max_num_results": 2018087 }

18013 }],

18014 "input": "What are the attributes of an ancient brown dragon?"

18015 }'18088 }'

18016```18089```

18017 18090 


18019 18092 

18020```json18093```json

18021{18094{

18022 "id": "resp_67ccf4c55fc48190b71bd0463ad3306d09504fb6872380d7",18095 "id": "resp_67ccd7eca01881908ff0b5146584e408072912b2993db808",

18023 "object": "response",18096 "object": "response",

18024 "created_at": 1741485253,18097 "created_at": 1741477868,

18025 "status": "completed",18098 "status": "completed",

18026 "completed_at": 1741485254,18099 "completed_at": 1741477869,

18027 "error": null,18100 "error": null,

18028 "incomplete_details": null,18101 "incomplete_details": null,

18029 "instructions": null,18102 "instructions": null,

18030 "max_output_tokens": null,18103 "max_output_tokens": null,

18031 "model": "gpt-5.4",18104 "model": "o1-2024-12-17",

18032 "output": [18105 "output": [

18033 {

18034 "type": "file_search_call",

18035 "id": "fs_67ccf4c63cd08190887ef6464ba5681609504fb6872380d7",

18036 "status": "completed",

18037 "queries": [

18038 "attributes of an ancient brown dragon"

18039 ],

18040 "results": null

18041 },

18042 {18106 {

18043 "type": "message",18107 "type": "message",

18044 "id": "msg_67ccf4c93e5c81909d595b369351a9d309504fb6872380d7",18108 "id": "msg_67ccd7f7b5848190a6f3e95d809f6b44072912b2993db808",

18045 "status": "completed",18109 "status": "completed",

18046 "role": "assistant",18110 "role": "assistant",

18047 "content": [18111 "content": [

18048 {18112 {

18049 "type": "output_text",18113 "type": "output_text",

18050 "text": "The attributes of an ancient brown dragon include...",18114 "text": "The classic tongue twister...",

18051 "annotations": [18115 "annotations": []

18052 {

18053 "type": "file_citation",

18054 "index": 320,

18055 "file_id": "file-4wDz5b167pAf72nx1h9eiN",

18056 "filename": "dragons.pdf"

18057 },

18058 {

18059 "type": "file_citation",

18060 "index": 576,

18061 "file_id": "file-4wDz5b167pAf72nx1h9eiN",

18062 "filename": "dragons.pdf"

18063 },

18064 {

18065 "type": "file_citation",

18066 "index": 815,

18067 "file_id": "file-4wDz5b167pAf72nx1h9eiN",

18068 "filename": "dragons.pdf"

18069 },

18070 {

18071 "type": "file_citation",

18072 "index": 815,

18073 "file_id": "file-4wDz5b167pAf72nx1h9eiN",

18074 "filename": "dragons.pdf"

18075 },

18076 {

18077 "type": "file_citation",

18078 "index": 1030,

18079 "file_id": "file-4wDz5b167pAf72nx1h9eiN",

18080 "filename": "dragons.pdf"

18081 },

18082 {

18083 "type": "file_citation",

18084 "index": 1030,

18085 "file_id": "file-4wDz5b167pAf72nx1h9eiN",

18086 "filename": "dragons.pdf"

18087 },

18088 {

18089 "type": "file_citation",

18090 "index": 1156,

18091 "file_id": "file-4wDz5b167pAf72nx1h9eiN",

18092 "filename": "dragons.pdf"

18093 },

18094 {

18095 "type": "file_citation",

18096 "index": 1225,

18097 "file_id": "file-4wDz5b167pAf72nx1h9eiN",

18098 "filename": "dragons.pdf"

18099 }

18100 ]

18101 }18116 }

18102 ]18117 ]

18103 }18118 }


18105 "parallel_tool_calls": true,18120 "parallel_tool_calls": true,

18106 "previous_response_id": null,18121 "previous_response_id": null,

18107 "reasoning": {18122 "reasoning": {

18108 "effort": null,18123 "effort": "high",

18109 "summary": null18124 "summary": null

18110 },18125 },

18111 "store": true,18126 "store": true,


18116 }18131 }

18117 },18132 },

18118 "tool_choice": "auto",18133 "tool_choice": "auto",

18119 "tools": [18134 "tools": [],

18120 {

18121 "type": "file_search",

18122 "filters": null,

18123 "max_num_results": 20,

18124 "ranking_options": {

18125 "ranker": "auto",

18126 "score_threshold": 0.0

18127 },

18128 "vector_store_ids": [

18129 "vs_1234567890"

18130 ]

18131 }

18132 ],

18133 "top_p": 1.0,18135 "top_p": 1.0,

18134 "truncation": "disabled",18136 "truncation": "disabled",

18135 "usage": {18137 "usage": {

18136 "input_tokens": 18307,18138 "input_tokens": 81,

18137 "input_tokens_details": {18139 "input_tokens_details": {

18138 "cached_tokens": 0,18140 "cached_tokens": 0,

18139 "cache_write_tokens": 018141 "cache_write_tokens": 0

18140 },18142 },

18141 "output_tokens": 348,18143 "output_tokens": 1035,

18142 "output_tokens_details": {18144 "output_tokens_details": {

18143 "reasoning_tokens": 018145 "reasoning_tokens": 832

18144 },18146 },

18145 "total_tokens": 1865518147 "total_tokens": 1116

18146 },18148 },

18147 "user": null,18149 "user": null,

18148 "metadata": {}18150 "metadata": {}


18196data: {"type":"response.completed","response":{"id":"resp_67c9fdcecf488190bdd9a0409de3a1ec07b8b0ad4e5eb654","object":"response","created_at":1741290958,"status":"completed","error":null,"incomplete_details":null,"instructions":"You are a helpful assistant.","max_output_tokens":null,"model":"gpt-5.4","output":[{"id":"msg_67c9fdcf37fc8190ba82116e33fb28c507b8b0ad4e5eb654","type":"message","status":"completed","role":"assistant","content":[{"type":"output_text","text":"Hi there! How can I assist you today?","annotations":[]}]}],"parallel_tool_calls":true,"previous_response_id":null,"reasoning":{"effort":null,"summary":null},"store":true,"temperature":1.0,"text":{"format":{"type":"text"}},"tool_choice":"auto","tools":[],"top_p":1.0,"truncation":"disabled","usage":{"input_tokens":37,"output_tokens":11,"output_tokens_details":{"reasoning_tokens":0},"total_tokens":48},"user":null,"metadata":{}}}18198data: {"type":"response.completed","response":{"id":"resp_67c9fdcecf488190bdd9a0409de3a1ec07b8b0ad4e5eb654","object":"response","created_at":1741290958,"status":"completed","error":null,"incomplete_details":null,"instructions":"You are a helpful assistant.","max_output_tokens":null,"model":"gpt-5.4","output":[{"id":"msg_67c9fdcf37fc8190ba82116e33fb28c507b8b0ad4e5eb654","type":"message","status":"completed","role":"assistant","content":[{"type":"output_text","text":"Hi there! How can I assist you today?","annotations":[]}]}],"parallel_tool_calls":true,"previous_response_id":null,"reasoning":{"effort":null,"summary":null},"store":true,"temperature":1.0,"text":{"format":{"type":"text"}},"tool_choice":"auto","tools":[],"top_p":1.0,"truncation":"disabled","usage":{"input_tokens":37,"output_tokens":11,"output_tokens_details":{"reasoning_tokens":0},"total_tokens":48},"user":null,"metadata":{}}}

18197```18199```

18198 18200 

18199### Functions18201### Text input

18200 18202 

18201```http18203```http

18202curl https://api.openai.com/v1/responses \18204curl https://api.openai.com/v1/responses \


18204 -H "Authorization: Bearer $OPENAI_API_KEY" \18206 -H "Authorization: Bearer $OPENAI_API_KEY" \

18205 -d '{18207 -d '{

18206 "model": "gpt-5.4",18208 "model": "gpt-5.4",

18207 "input": "What is the weather like in Boston today?",18209 "input": "Tell me a three sentence bedtime story about a unicorn."

18208 "tools": [

18209 {

18210 "type": "function",

18211 "name": "get_current_weather",

18212 "description": "Get the current weather in a given location",

18213 "parameters": {

18214 "type": "object",

18215 "properties": {

18216 "location": {

18217 "type": "string",

18218 "description": "The city and state, e.g. San Francisco, CA"

18219 },

18220 "unit": {

18221 "type": "string",

18222 "enum": ["celsius", "fahrenheit"]

18223 }

18224 },

18225 "required": ["location", "unit"]

18226 }

18227 }

18228 ],

18229 "tool_choice": "auto"

18230 }'18210 }'

18231```18211```

18232 18212 


18234 18214 

18235```json18215```json

18236{18216{

18237 "id": "resp_67ca09c5efe0819096d0511c92b8c890096610f474011cc0",18217 "id": "resp_67ccd2bed1ec8190b14f964abc0542670bb6a6b452d3795b",

18238 "object": "response",18218 "object": "response",

18239 "created_at": 1741294021,18219 "created_at": 1741476542,

18240 "status": "completed",18220 "status": "completed",

18241 "completed_at": 1741294022,18221 "completed_at": 1741476543,

18242 "error": null,18222 "error": null,

18243 "incomplete_details": null,18223 "incomplete_details": null,

18244 "instructions": null,18224 "instructions": null,


18246 "model": "gpt-5.4",18226 "model": "gpt-5.4",

18247 "output": [18227 "output": [

18248 {18228 {

18249 "type": "function_call",18229 "type": "message",

18250 "id": "fc_67ca09c6bedc8190a7abfec07b1a1332096610f474011cc0",18230 "id": "msg_67ccd2bf17f0819081ff3bb2cf6508e60bb6a6b452d3795b",

18251 "call_id": "call_unLAR8MvFNptuiZK6K6HCy5k",18231 "status": "completed",

18252 "name": "get_current_weather",18232 "role": "assistant",

18253 "arguments": "{\"location\":\"Boston, MA\",\"unit\":\"celsius\"}",18233 "content": [

18254 "status": "completed"18234 {

18235 "type": "output_text",

18236 "text": "In a peaceful grove beneath a silver moon, a unicorn named Lumina discovered a hidden pool that reflected the stars. As she dipped her horn into the water, the pool began to shimmer, revealing a pathway to a magical realm of endless night skies. Filled with wonder, Lumina whispered a wish for all who dream to find their own hidden magic, and as she glanced back, her hoofprints sparkled like stardust.",

18237 "annotations": []

18238 }

18239 ]

18255 }18240 }

18256 ],18241 ],

18257 "parallel_tool_calls": true,18242 "parallel_tool_calls": true,


18268 }18253 }

18269 },18254 },

18270 "tool_choice": "auto",18255 "tool_choice": "auto",

18271 "tools": [18256 "tools": [],

18272 {

18273 "type": "function",

18274 "description": "Get the current weather in a given location",

18275 "name": "get_current_weather",

18276 "parameters": {

18277 "type": "object",

18278 "properties": {

18279 "location": {

18280 "type": "string",

18281 "description": "The city and state, e.g. San Francisco, CA"

18282 },

18283 "unit": {

18284 "type": "string",

18285 "enum": [

18286 "celsius",

18287 "fahrenheit"

18288 ]

18289 }

18290 },

18291 "required": [

18292 "location",

18293 "unit"

18294 ]

18295 },

18296 "strict": true

18297 }

18298 ],

18299 "top_p": 1.0,18257 "top_p": 1.0,

18300 "truncation": "disabled",18258 "truncation": "disabled",

18301 "usage": {18259 "usage": {

18302 "input_tokens": 291,18260 "input_tokens": 36,

18303 "output_tokens": 23,18261 "input_tokens_details": {

18262 "cached_tokens": 0,

18263 "cache_write_tokens": 0

18264 },

18265 "output_tokens": 87,

18304 "output_tokens_details": {18266 "output_tokens_details": {

18305 "reasoning_tokens": 018267 "reasoning_tokens": 0

18306 },18268 },

18307 "total_tokens": 31418269 "total_tokens": 123

18308 },18270 },

18309 "user": null,18271 "user": null,

18310 "metadata": {}18272 "metadata": {}

18311}18273}

18312```18274```

18313 18275 

18314### Reasoning18276### Web search

18315 18277 

18316```http18278```http

18317curl https://api.openai.com/v1/responses \18279curl https://api.openai.com/v1/responses \

18318 -H "Content-Type: application/json" \18280 -H "Content-Type: application/json" \

18319 -H "Authorization: Bearer $OPENAI_API_KEY" \18281 -H "Authorization: Bearer $OPENAI_API_KEY" \

18320 -d '{18282 -d '{

18321 "model": "o3-mini",18283 "model": "gpt-5.4",

18322 "input": "How much wood would a woodchuck chuck?",18284 "tools": [{ "type": "web_search_preview" }],

18323 "reasoning": {18285 "input": "What was a positive news story from today?"

18324 "effort": "high"

18325 }

18326 }'18286 }'

18327```18287```

18328 18288 


18330 18290 

18331```json18291```json

18332{18292{

18333 "id": "resp_67ccd7eca01881908ff0b5146584e408072912b2993db808",18293 "id": "resp_67ccf18ef5fc8190b16dbee19bc54e5f087bb177ab789d5c",

18334 "object": "response",18294 "object": "response",

18335 "created_at": 1741477868,18295 "created_at": 1741484430,

18336 "status": "completed",18296 "status": "completed",

18337 "completed_at": 1741477869,18297 "completed_at": 1741484431,

18338 "error": null,18298 "error": null,

18339 "incomplete_details": null,18299 "incomplete_details": null,

18340 "instructions": null,18300 "instructions": null,

18341 "max_output_tokens": null,18301 "max_output_tokens": null,

18342 "model": "o1-2024-12-17",18302 "model": "gpt-5.4",

18343 "output": [18303 "output": [

18304 {

18305 "type": "web_search_call",

18306 "id": "ws_67ccf18f64008190a39b619f4c8455ef087bb177ab789d5c",

18307 "status": "completed"

18308 },

18344 {18309 {

18345 "type": "message",18310 "type": "message",

18346 "id": "msg_67ccd7f7b5848190a6f3e95d809f6b44072912b2993db808",18311 "id": "msg_67ccf190ca3881909d433c50b1f6357e087bb177ab789d5c",

18347 "status": "completed",18312 "status": "completed",

18348 "role": "assistant",18313 "role": "assistant",

18349 "content": [18314 "content": [

18350 {18315 {

18351 "type": "output_text",18316 "type": "output_text",

18352 "text": "The classic tongue twister...",18317 "text": "As of today, March 9, 2025, one notable positive news story...",

18353 "annotations": []18318 "annotations": [

18319 {

18320 "type": "url_citation",

18321 "start_index": 442,

18322 "end_index": 557,

18323 "url": "https://.../?utm_source=chatgpt.com",

18324 "title": "..."

18325 },

18326 {

18327 "type": "url_citation",

18328 "start_index": 962,

18329 "end_index": 1077,

18330 "url": "https://.../?utm_source=chatgpt.com",

18331 "title": "..."

18332 },

18333 {

18334 "type": "url_citation",

18335 "start_index": 1336,

18336 "end_index": 1451,

18337 "url": "https://.../?utm_source=chatgpt.com",

18338 "title": "..."

18339 }

18340 ]

18354 }18341 }

18355 ]18342 ]

18356 }18343 }


18358 "parallel_tool_calls": true,18345 "parallel_tool_calls": true,

18359 "previous_response_id": null,18346 "previous_response_id": null,

18360 "reasoning": {18347 "reasoning": {

18361 "effort": "high",18348 "effort": null,

18362 "summary": null18349 "summary": null

18363 },18350 },

18364 "store": true,18351 "store": true,


18369 }18356 }

18370 },18357 },

18371 "tool_choice": "auto",18358 "tool_choice": "auto",

18372 "tools": [],18359 "tools": [

18360 {

18361 "type": "web_search_preview",

18362 "domains": [],

18363 "search_context_size": "medium",

18364 "user_location": {

18365 "type": "approximate",

18366 "city": null,

18367 "country": "US",

18368 "region": null,

18369 "timezone": null

18370 }

18371 }

18372 ],

18373 "top_p": 1.0,18373 "top_p": 1.0,

18374 "truncation": "disabled",18374 "truncation": "disabled",

18375 "usage": {18375 "usage": {

18376 "input_tokens": 81,18376 "input_tokens": 328,

18377 "input_tokens_details": {18377 "input_tokens_details": {

18378 "cached_tokens": 0,18378 "cached_tokens": 0,

18379 "cache_write_tokens": 018379 "cache_write_tokens": 0

18380 },18380 },

18381 "output_tokens": 1035,18381 "output_tokens": 356,

18382 "output_tokens_details": {18382 "output_tokens_details": {

18383 "reasoning_tokens": 83218383 "reasoning_tokens": 0

18384 },18384 },

18385 "total_tokens": 111618385 "total_tokens": 684

18386 },18386 },

18387 "user": null,18387 "user": null,

18388 "metadata": {}18388 "metadata": {}

Details

4 4 

5Deletes a model response with the given ID.5Deletes a model response with the given ID.

6 6 

7### Path Parameters

8 

9- `response_id: string`

10 

11### Header Parameters7### Header Parameters

12 8 

13- `"openai-beta": optional array of "responses_multi_agent=v1"`9- `"openai-beta": optional array of "responses_multi_agent=v1"`

14 10 

15 - `"responses_multi_agent=v1"`11 - `"responses_multi_agent=v1"`

16 12 

13### Path Parameters

14 

15- `response_id: string`

16 

17### Example17### Example

18 18 

19```http19```http

Details

4 4 

5Retrieves a model response with the given ID.5Retrieves a model response with the given ID.

6 6 

7### Header Parameters

8 

9- `"openai-beta": optional array of "responses_multi_agent=v1"`

10 

11 - `"responses_multi_agent=v1"`

12 

7### Path Parameters13### Path Parameters

8 14 

9- `response_id: string`15- `response_id: string`


54 60 

55 - `false`61 - `false`

56 62 

57### Header Parameters

58 

59- `"openai-beta": optional array of "responses_multi_agent=v1"`

60 

61 - `"responses_multi_agent=v1"`

62 

63### Returns63### Returns

64 64 

65- `BetaResponse object { id, created_at, error, 32 more }`65- `BetaResponse object { id, created_at, error, 32 more }`

Details

4 4 

5Returns a list of input items for a given response.5Returns a list of input items for a given response.

6 6 

7### Header Parameters

8 

9- `"openai-beta": optional array of "responses_multi_agent=v1"`

10 

11 - `"responses_multi_agent=v1"`

12 

7### Path Parameters13### Path Parameters

8 14 

9- `response_id: string`15- `response_id: string`


51 57 

52 - `"desc"`58 - `"desc"`

53 59 

54### Header Parameters

55 

56- `"openai-beta": optional array of "responses_multi_agent=v1"`

57 

58 - `"responses_multi_agent=v1"`

59 

60### Returns60### Returns

61 61 

62- `BetaResponseItemList object { data, first_id, has_more, 2 more }`62- `BetaResponseItemList object { data, first_id, has_more, 2 more }`

Details

169 169 

170 The chunking strategy used to chunk the file(s). If not set, will use the `auto` strategy.170 The chunking strategy used to chunk the file(s). If not set, will use the `auto` strategy.

171 171 

172 - `AutoChunkingStrategy object { type }`172 - `Auto object { type }`

173 173 

174 The default strategy. This strategy currently uses a `max_chunk_size_tokens` of `800` and `chunk_overlap_tokens` of `400`.174 The default strategy. This strategy currently uses a `max_chunk_size_tokens` of `800` and `chunk_overlap_tokens` of `400`.

175 175 


179 179 

180 - `"auto"`180 - `"auto"`

181 181 

182 - `StaticChunkingStrategy object { static, type }`182 - `Static object { static, type }`

183 183 

184 - `static: object { chunk_overlap_tokens, max_chunk_size_tokens }`184 - `static: object { chunk_overlap_tokens, max_chunk_size_tokens }`

185 185 

Details

374 374 

375 The chunking strategy used to chunk the file(s). If not set, will use the `auto` strategy.375 The chunking strategy used to chunk the file(s). If not set, will use the `auto` strategy.

376 376 

377 - `AutoChunkingStrategy object { type }`377 - `Auto object { type }`

378 378 

379 The default strategy. This strategy currently uses a `max_chunk_size_tokens` of `800` and `chunk_overlap_tokens` of `400`.379 The default strategy. This strategy currently uses a `max_chunk_size_tokens` of `800` and `chunk_overlap_tokens` of `400`.

380 380 


384 384 

385 - `"auto"`385 - `"auto"`

386 386 

387 - `StaticChunkingStrategy object { static, type }`387 - `Static object { static, type }`

388 388 

389 - `static: object { chunk_overlap_tokens, max_chunk_size_tokens }`389 - `static: object { chunk_overlap_tokens, max_chunk_size_tokens }`

390 390 

Details

1258 1258 

1259 The input format for the custom tool. Default is unconstrained text.1259 The input format for the custom tool. Default is unconstrained text.

1260 1260 

1261 - `TextFormat object { type }`1261 - `Text object { type }`

1262 1262 

1263 Unconstrained free-form text.1263 Unconstrained free-form text.

1264 1264 


1268 1268 

1269 - `"text"`1269 - `"text"`

1270 1270 

1271 - `GrammarFormat object { grammar, type }`1271 - `Grammar object { grammar, type }`

1272 1272 

1273 A grammar defined by the user.1273 A grammar defined by the user.

1274 1274 


2100}2100}

2101```2101```

2102 2102 

2103### Image input

2104 

2105```http

2106curl https://api.openai.com/v1/chat/completions \

2107 -H "Content-Type: application/json" \

2108 -H "Authorization: Bearer $OPENAI_API_KEY" \

2109 -d '{

2110 "model": "gpt-5.4",

2111 "messages": [

2112 {

2113 "role": "user",

2114 "content": [

2115 {

2116 "type": "text",

2117 "text": "What is in this image?"

2118 },

2119 {

2120 "type": "image_url",

2121 "image_url": {

2122 "url": "https://upload.wikimedia.org/wikipedia/commons/thumb/d/dd/Gfp-wisconsin-madison-the-nature-boardwalk.jpg/2560px-Gfp-wisconsin-madison-the-nature-boardwalk.jpg"

2123 }

2124 }

2125 ]

2126 }

2127 ],

2128 "max_tokens": 300

2129 }'

2130```

2131 

2132#### Response

2133 

2134```json

2135{

2136 "id": "chatcmpl-B9MHDbslfkBeAs8l4bebGdFOJ6PeG",

2137 "object": "chat.completion",

2138 "created": 1741570283,

2139 "model": "gpt-5.4",

2140 "choices": [

2141 {

2142 "index": 0,

2143 "message": {

2144 "role": "assistant",

2145 "content": "The image shows a wooden boardwalk path running through a lush green field or meadow. The sky is bright blue with some scattered clouds, giving the scene a serene and peaceful atmosphere. Trees and shrubs are visible in the background.",

2146 "refusal": null,

2147 "annotations": []

2148 },

2149 "logprobs": null,

2150 "finish_reason": "stop"

2151 }

2152 ],

2153 "usage": {

2154 "prompt_tokens": 1117,

2155 "completion_tokens": 46,

2156 "total_tokens": 1163,

2157 "prompt_tokens_details": {

2158 "cached_tokens": 0,

2159 "audio_tokens": 0

2160 },

2161 "completion_tokens_details": {

2162 "reasoning_tokens": 0,

2163 "audio_tokens": 0,

2164 "accepted_prediction_tokens": 0,

2165 "rejected_prediction_tokens": 0

2166 }

2167 },

2168 "service_tier": "default"

2169}

2170```

2171 

2172### Streaming

2173 

2174```http

2175curl https://api.openai.com/v1/chat/completions \

2176 -H "Content-Type: application/json" \

2177 -H "Authorization: Bearer $OPENAI_API_KEY" \

2178 -d '{

2179 "model": "VAR_chat_model_id",

2180 "messages": [

2181 {

2182 "role": "developer",

2183 "content": "You are a helpful assistant."

2184 },

2185 {

2186 "role": "user",

2187 "content": "Hello!"

2188 }

2189 ],

2190 "stream": true

2191 }'

2192```

2193 

2194#### Response

2195 

2196```json

2197{"id":"chatcmpl-123","object":"chat.completion.chunk","created":1694268190,"model":"gpt-4o-mini", "system_fingerprint": "fp_44709d6fcb", "choices":[{"index":0,"delta":{"role":"assistant","content":""},"logprobs":null,"finish_reason":null}]}

2198 

2199{"id":"chatcmpl-123","object":"chat.completion.chunk","created":1694268190,"model":"gpt-4o-mini", "system_fingerprint": "fp_44709d6fcb", "choices":[{"index":0,"delta":{"content":"Hello"},"logprobs":null,"finish_reason":null}]}

2200 

2201....

2202 

2203{"id":"chatcmpl-123","object":"chat.completion.chunk","created":1694268190,"model":"gpt-4o-mini", "system_fingerprint": "fp_44709d6fcb", "choices":[{"index":0,"delta":{},"logprobs":null,"finish_reason":"stop"}]}

2204```

2205 

2206### Functions2103### Functions

2207 2104 

2208```http2105```http


2286}2183}

2287```2184```

2288 2185 

2186### Image input

2187 

2188```http

2189curl https://api.openai.com/v1/chat/completions \

2190 -H "Content-Type: application/json" \

2191 -H "Authorization: Bearer $OPENAI_API_KEY" \

2192 -d '{

2193 "model": "gpt-5.4",

2194 "messages": [

2195 {

2196 "role": "user",

2197 "content": [

2198 {

2199 "type": "text",

2200 "text": "What is in this image?"

2201 },

2202 {

2203 "type": "image_url",

2204 "image_url": {

2205 "url": "https://upload.wikimedia.org/wikipedia/commons/thumb/d/dd/Gfp-wisconsin-madison-the-nature-boardwalk.jpg/2560px-Gfp-wisconsin-madison-the-nature-boardwalk.jpg"

2206 }

2207 }

2208 ]

2209 }

2210 ],

2211 "max_tokens": 300

2212 }'

2213```

2214 

2215#### Response

2216 

2217```json

2218{

2219 "id": "chatcmpl-B9MHDbslfkBeAs8l4bebGdFOJ6PeG",

2220 "object": "chat.completion",

2221 "created": 1741570283,

2222 "model": "gpt-5.4",

2223 "choices": [

2224 {

2225 "index": 0,

2226 "message": {

2227 "role": "assistant",

2228 "content": "The image shows a wooden boardwalk path running through a lush green field or meadow. The sky is bright blue with some scattered clouds, giving the scene a serene and peaceful atmosphere. Trees and shrubs are visible in the background.",

2229 "refusal": null,

2230 "annotations": []

2231 },

2232 "logprobs": null,

2233 "finish_reason": "stop"

2234 }

2235 ],

2236 "usage": {

2237 "prompt_tokens": 1117,

2238 "completion_tokens": 46,

2239 "total_tokens": 1163,

2240 "prompt_tokens_details": {

2241 "cached_tokens": 0,

2242 "audio_tokens": 0

2243 },

2244 "completion_tokens_details": {

2245 "reasoning_tokens": 0,

2246 "audio_tokens": 0,

2247 "accepted_prediction_tokens": 0,

2248 "rejected_prediction_tokens": 0

2249 }

2250 },

2251 "service_tier": "default"

2252}

2253```

2254 

2289### Logprobs2255### Logprobs

2290 2256 

2291```http2257```http


2498 "system_fingerprint": null2464 "system_fingerprint": null

2499}2465}

2500```2466```

2467 

2468### Streaming

2469 

2470```http

2471curl https://api.openai.com/v1/chat/completions \

2472 -H "Content-Type: application/json" \

2473 -H "Authorization: Bearer $OPENAI_API_KEY" \

2474 -d '{

2475 "model": "VAR_chat_model_id",

2476 "messages": [

2477 {

2478 "role": "developer",

2479 "content": "You are a helpful assistant."

2480 },

2481 {

2482 "role": "user",

2483 "content": "Hello!"

2484 }

2485 ],

2486 "stream": true

2487 }'

2488```

2489 

2490#### Response

2491 

2492```json

2493{"id":"chatcmpl-123","object":"chat.completion.chunk","created":1694268190,"model":"gpt-4o-mini", "system_fingerprint": "fp_44709d6fcb", "choices":[{"index":0,"delta":{"role":"assistant","content":""},"logprobs":null,"finish_reason":null}]}

2494 

2495{"id":"chatcmpl-123","object":"chat.completion.chunk","created":1694268190,"model":"gpt-4o-mini", "system_fingerprint": "fp_44709d6fcb", "choices":[{"index":0,"delta":{"content":"Hello"},"logprobs":null,"finish_reason":null}]}

2496 

2497....

2498 

2499{"id":"chatcmpl-123","object":"chat.completion.chunk","created":1694268190,"model":"gpt-4o-mini", "system_fingerprint": "fp_44709d6fcb", "choices":[{"index":0,"delta":{},"logprobs":null,"finish_reason":"stop"}]}

2500```

Details

1# Chat Completions streaming events1# Chat Completions streaming events

2 2 

3> For the complete documentation index, see [llms.txt](/llms.txt). Markdown versions of documentation pages are available by appending `.md` to the page URL.

4 

3Stream Chat Completions in real time. Receive chunks of completions5Stream Chat Completions in real time. Receive chunks of completions

4returned from the model using server-sent events.6returned from the model using server-sent events.

5[Learn more](https://developers.openai.com/docs/guides/streaming-responses?api-mode=chat).7[Learn more](https://developers.openai.com/docs/guides/streaming-responses?api-mode=chat).


19 "(resource) chat.completions > (model) chat_completion_chunk > (schema)": {21 "(resource) chat.completions > (model) chat_completion_chunk > (schema)": {

20 "kind": "HttpDeclTypeAlias",22 "kind": "HttpDeclTypeAlias",

21 "oasRef": "#/components/schemas/CreateChatCompletionStreamResponse",23 "oasRef": "#/components/schemas/CreateChatCompletionStreamResponse",

24 "docstring": "Represents a streamed chunk of a chat completion response returned\nby the model, based on the provided input. \n[Learn more](/docs/guides/streaming-responses).\n",

22 "ident": "ChatCompletionChunk",25 "ident": "ChatCompletionChunk",

23 "type": {26 "type": {

24 "kind": "HttpTypeObject",27 "kind": "HttpTypeObject",


52 }55 }

53 ]56 ]

54 },57 },

55 "docstring": "Represents a streamed chunk of a chat completion response returned\nby the model, based on the provided input. \n[Learn more](/docs/guides/streaming-responses).\n",

56 "childrenParentSchema": "object",58 "childrenParentSchema": "object",

57 "children": [59 "children": [

58 "(resource) chat.completions > (model) chat_completion_chunk > (schema) > (property) id",60 "(resource) chat.completions > (model) chat_completion_chunk > (schema) > (property) id",


68 },70 },

69 "(resource) chat.completions > (model) chat_completion_chunk > (schema) > (property) id": {71 "(resource) chat.completions > (model) chat_completion_chunk > (schema) > (property) id": {

70 "kind": "HttpDeclProperty",72 "kind": "HttpDeclProperty",

71 "docstring": "A unique identifier for the chat completion. Each chunk has the same ID.",73 "oasRef": "#/components/schemas/CreateChatCompletionStreamResponse/properties/id",

74 "deprecated": false,

72 "key": "id",75 "key": "id",

73 "optional": false,76 "docstring": "A unique identifier for the chat completion. Each chunk has the same ID.",

74 "nullable": false,

75 "type": {77 "type": {

76 "kind": "HttpTypeString"78 "kind": "HttpTypeString"

77 },79 },

78 "oasRef": "#/components/schemas/CreateChatCompletionStreamResponse/properties/id",80 "optional": false,

79 "deprecated": false,81 "nullable": false,

80 "schemaType": "string",82 "schemaType": "string",

81 "children": []83 "children": []

82 },84 },

83 "(resource) chat.completions > (model) chat_completion_chunk > (schema) > (property) choices": {85 "(resource) chat.completions > (model) chat_completion_chunk > (schema) > (property) choices": {

84 "kind": "HttpDeclProperty",86 "kind": "HttpDeclProperty",

85 "docstring": "A list of chat completion choices. Can contain more than one elements if `n` is greater than 1. Can also be empty for the\nlast chunk if you set `stream_options: {\"include_usage\": true}`.\n",87 "oasRef": "#/components/schemas/CreateChatCompletionStreamResponse/properties/choices",

88 "deprecated": false,

86 "key": "choices",89 "key": "choices",

87 "optional": false,90 "docstring": "A list of chat completion choices. Can contain more than one elements if `n` is greater than 1. Can also be empty for the\nlast chunk if you set `stream_options: {\"include_usage\": true}`.\n",

88 "nullable": false,

89 "type": {91 "type": {

90 "kind": "HttpTypeArray",92 "kind": "HttpTypeArray",

93 "oasRef": "#/components/schemas/CreateChatCompletionStreamResponse/properties/choices",

91 "elementType": {94 "elementType": {

92 "kind": "HttpTypeObject",95 "kind": "HttpTypeObject",

93 "members": [96 "members": [


104 "ident": "logprobs"107 "ident": "logprobs"

105 }108 }

106 ]109 ]

110 }

107 },111 },

108 "oasRef": "#/components/schemas/CreateChatCompletionStreamResponse/properties/choices"112 "optional": false,

109 },113 "nullable": false,

110 "oasRef": "#/components/schemas/CreateChatCompletionStreamResponse/properties/choices",

111 "deprecated": false,

112 "schemaType": "array",114 "schemaType": "array",

113 "childrenParentSchema": "object",115 "childrenParentSchema": "object",

114 "children": [116 "children": [


120 },122 },

121 "(resource) chat.completions > (model) chat_completion_chunk > (schema) > (property) created": {123 "(resource) chat.completions > (model) chat_completion_chunk > (schema) > (property) created": {

122 "kind": "HttpDeclProperty",124 "kind": "HttpDeclProperty",

123 "docstring": "The Unix timestamp (in seconds) of when the chat completion was created. Each chunk has the same timestamp.",125 "oasRef": "#/components/schemas/CreateChatCompletionStreamResponse/properties/created",

126 "deprecated": false,

124 "key": "created",127 "key": "created",

125 "optional": false,128 "docstring": "The Unix timestamp (in seconds) of when the chat completion was created. Each chunk has the same timestamp.",

126 "nullable": false,

127 "type": {129 "type": {

128 "kind": "HttpTypeNumber"130 "kind": "HttpTypeNumber"

129 },131 },

130 "constraints": {132 "constraints": {

131 "format": "unixtime"133 "format": "unixtime"

132 },134 },

133 "oasRef": "#/components/schemas/CreateChatCompletionStreamResponse/properties/created",135 "optional": false,

134 "deprecated": false,136 "nullable": false,

135 "schemaType": "integer",137 "schemaType": "integer",

136 "children": []138 "children": []

137 },139 },

138 "(resource) chat.completions > (model) chat_completion_chunk > (schema) > (property) model": {140 "(resource) chat.completions > (model) chat_completion_chunk > (schema) > (property) model": {

139 "kind": "HttpDeclProperty",141 "kind": "HttpDeclProperty",

140 "docstring": "The model to generate the completion.",142 "oasRef": "#/components/schemas/CreateChatCompletionStreamResponse/properties/model",

143 "deprecated": false,

141 "key": "model",144 "key": "model",

142 "optional": false,145 "docstring": "The model to generate the completion.",

143 "nullable": false,

144 "type": {146 "type": {

145 "kind": "HttpTypeString"147 "kind": "HttpTypeString"

146 },148 },

147 "oasRef": "#/components/schemas/CreateChatCompletionStreamResponse/properties/model",149 "optional": false,

148 "deprecated": false,150 "nullable": false,

149 "schemaType": "string",151 "schemaType": "string",

150 "children": []152 "children": []

151 },153 },

152 "(resource) chat.completions > (model) chat_completion_chunk > (schema) > (property) object": {154 "(resource) chat.completions > (model) chat_completion_chunk > (schema) > (property) object": {

153 "kind": "HttpDeclProperty",155 "kind": "HttpDeclProperty",

154 "docstring": "The object type, which is always `chat.completion.chunk`.",156 "oasRef": "#/components/schemas/CreateChatCompletionStreamResponse/properties/object",

157 "deprecated": false,

155 "key": "object",158 "key": "object",

156 "optional": false,159 "docstring": "The object type, which is always `chat.completion.chunk`.",

157 "nullable": false,

158 "type": {160 "type": {

159 "kind": "HttpTypeUnion",161 "kind": "HttpTypeUnion",

162 "oasRef": "#/components/schemas/CreateChatCompletionStreamResponse/properties/object",

160 "types": [163 "types": [

161 {164 {

162 "kind": "HttpTypeLiteral",165 "kind": "HttpTypeLiteral",

163 "literal": "chat.completion.chunk"166 "literal": "chat.completion.chunk"

164 }167 }

165 ],168 ]

166 "oasRef": "#/components/schemas/CreateChatCompletionStreamResponse/properties/object"

167 },169 },

168 "oasRef": "#/components/schemas/CreateChatCompletionStreamResponse/properties/object",170 "optional": false,

169 "deprecated": false,171 "nullable": false,

170 "schemaType": "enum",172 "schemaType": "enum",

171 "childrenParentSchema": "enum",173 "childrenParentSchema": "enum",

172 "children": [174 "children": [


175 },177 },

176 "(resource) chat.completions > (model) chat_completion_chunk > (schema) > (property) moderation": {178 "(resource) chat.completions > (model) chat_completion_chunk > (schema) > (property) moderation": {

177 "kind": "HttpDeclProperty",179 "kind": "HttpDeclProperty",

178 "docstring": "Moderation results for the request input and generated output. Present\non the moderation chunk when moderated completions are requested.\n",180 "oasRef": "#/components/schemas/CreateChatCompletionStreamResponse/properties/moderation",

181 "deprecated": false,

179 "key": "moderation",182 "key": "moderation",

180 "optional": true,183 "docstring": "Moderation results for the request input and generated output. Present\non the moderation chunk when moderated completions are requested.\n",

181 "nullable": true,

182 "type": {184 "type": {

183 "kind": "HttpTypeObject",185 "kind": "HttpTypeObject",

184 "members": [186 "members": [


190 }192 }

191 ]193 ]

192 },194 },

193 "oasRef": "#/components/schemas/CreateChatCompletionStreamResponse/properties/moderation",195 "optional": true,

194 "deprecated": false,196 "nullable": true,

195 "schemaType": "object",197 "schemaType": "object",

196 "childrenParentSchema": "object",198 "childrenParentSchema": "object",

197 "children": [199 "children": [


201 },203 },

202 "(resource) chat.completions > (model) chat_completion_chunk > (schema) > (property) service_tier": {204 "(resource) chat.completions > (model) chat_completion_chunk > (schema) > (property) service_tier": {

203 "kind": "HttpDeclProperty",205 "kind": "HttpDeclProperty",

204 "docstring": "Specifies the processing type used for serving the request.\n - If set to 'auto', then the request will be processed with the service tier configured in the Project settings. Unless otherwise configured, the Project will use 'default'.\n - If set to 'default', then the request will be processed with the standard pricing and performance for the selected model.\n - If set to '[flex](/docs/guides/flex-processing)' or '[priority](https://openai.com/api-priority-processing/)', then the request will be processed with the corresponding service tier.\n - When not set, the default behavior is 'auto'.\n\n When the `service_tier` parameter is set, the response body will include the `service_tier` value based on the processing mode actually used to serve the request. This response value may be different from the value set in the parameter.\n",206 "oasRef": "#/components/schemas/CreateChatCompletionStreamResponse/properties/service_tier",

207 "deprecated": false,

205 "key": "service_tier",208 "key": "service_tier",

206 "optional": true,209 "docstring": "Specifies the processing type used for serving the request.\n - If set to 'auto', then the request will be processed with the service tier configured in the Project settings. Unless otherwise configured, the Project will use 'default'.\n - If set to 'default', then the request will be processed with the standard pricing and performance for the selected model.\n - If set to '[flex](/docs/guides/flex-processing)' or '[priority](https://openai.com/api-priority-processing/)', then the request will be processed with the corresponding service tier.\n - When not set, the default behavior is 'auto'.\n\n When the `service_tier` parameter is set, the response body will include the `service_tier` value based on the processing mode actually used to serve the request. This response value may be different from the value set in the parameter.\n",

207 "nullable": true,

208 "default": "auto",

209 "type": {210 "type": {

210 "kind": "HttpTypeUnion",211 "kind": "HttpTypeUnion",

212 "oasRef": "#/components/schemas/CreateChatCompletionStreamResponse/properties/service_tier",

211 "types": [213 "types": [

212 {214 {

213 "kind": "HttpTypeLiteral",215 "kind": "HttpTypeLiteral",


229 "kind": "HttpTypeLiteral",231 "kind": "HttpTypeLiteral",

230 "literal": "priority"232 "literal": "priority"

231 }233 }

232 ],234 ]

233 "oasRef": "#/components/schemas/CreateChatCompletionStreamResponse/properties/service_tier"

234 },235 },

235 "oasRef": "#/components/schemas/CreateChatCompletionStreamResponse/properties/service_tier",236 "default": "auto",

236 "deprecated": false,237 "optional": true,

238 "nullable": true,

237 "schemaType": "enum",239 "schemaType": "enum",

238 "childrenParentSchema": "enum",240 "childrenParentSchema": "enum",

239 "children": [241 "children": [


246 },248 },

247 "(resource) chat.completions > (model) chat_completion_chunk > (schema) > (property) system_fingerprint": {249 "(resource) chat.completions > (model) chat_completion_chunk > (schema) > (property) system_fingerprint": {

248 "kind": "HttpDeclProperty",250 "kind": "HttpDeclProperty",

249 "docstring": "This fingerprint represents the backend configuration that the model runs with.\nCan be used in conjunction with the `seed` request parameter to understand when backend changes have been made that might impact determinism.\n",251 "oasRef": "#/components/schemas/CreateChatCompletionStreamResponse/properties/system_fingerprint",

252 "deprecated": true,

250 "key": "system_fingerprint",253 "key": "system_fingerprint",

251 "optional": true,254 "docstring": "This fingerprint represents the backend configuration that the model runs with.\nCan be used in conjunction with the `seed` request parameter to understand when backend changes have been made that might impact determinism.\n",

252 "nullable": false,

253 "type": {255 "type": {

254 "kind": "HttpTypeString"256 "kind": "HttpTypeString"

255 },257 },

256 "oasRef": "#/components/schemas/CreateChatCompletionStreamResponse/properties/system_fingerprint",258 "optional": true,

257 "deprecated": true,259 "nullable": false,

258 "schemaType": "string",260 "schemaType": "string",

259 "children": []261 "children": []

260 },262 },

261 "(resource) chat.completions > (model) chat_completion_chunk > (schema) > (property) usage": {263 "(resource) chat.completions > (model) chat_completion_chunk > (schema) > (property) usage": {

262 "kind": "HttpDeclProperty",264 "kind": "HttpDeclProperty",

263 "docstring": "An optional field that will only be present when you set\n`stream_options: {\"include_usage\": true}` in your request. When present, it\ncontains a null value **except for the last chunk** which contains the\ntoken usage statistics for the entire request.\n\n**NOTE:** If the stream is interrupted or cancelled, you may not\nreceive the final usage chunk which contains the total token usage for\nthe request.\n",265 "oasRef": "#/components/schemas/CreateChatCompletionStreamResponse/properties/usage",

266 "deprecated": false,

264 "key": "usage",267 "key": "usage",

265 "optional": true,268 "docstring": "An optional field that will only be present when you set\n`stream_options: {\"include_usage\": true}` in your request. When present, it\ncontains a null value **except for the last chunk** which contains the\ntoken usage statistics for the entire request.\n\n**NOTE:** If the stream is interrupted or cancelled, you may not\nreceive the final usage chunk which contains the total token usage for\nthe request.\n",

266 "nullable": true,

267 "type": {269 "type": {

268 "kind": "HttpTypeReference",270 "kind": "HttpTypeReference",

269 "ident": "CompletionUsage",271 "ident": "CompletionUsage",

270 "$ref": "(resource) completions > (model) completion_usage > (schema)"272 "$ref": "(resource) completions > (model) completion_usage > (schema)"

271 },273 },

272 "oasRef": "#/components/schemas/CreateChatCompletionStreamResponse/properties/usage",274 "optional": true,

273 "deprecated": false,275 "nullable": true,

274 "schemaType": "object",

275 "modelImplicit": false,276 "modelImplicit": false,

277 "schemaType": "object",

276 "modelPath": "(resource) completions > (model) completion_usage",278 "modelPath": "(resource) completions > (model) completion_usage",

277 "childrenParentSchema": "object",279 "childrenParentSchema": "object",

278 "children": [280 "children": [


285 },287 },

286 "(resource) chat.completions > (model) chat_completion_chunk > (schema) > (property) choices > (items) > (property) delta": {288 "(resource) chat.completions > (model) chat_completion_chunk > (schema) > (property) choices > (items) > (property) delta": {

287 "kind": "HttpDeclProperty",289 "kind": "HttpDeclProperty",

288 "docstring": "A chat completion delta generated by streamed model responses.",290 "oasRef": "#/components/schemas/CreateChatCompletionStreamResponse/properties/choices/items/properties/delta",

291 "deprecated": false,

289 "key": "delta",292 "key": "delta",

290 "optional": false,293 "docstring": "A chat completion delta generated by streamed model responses.",

291 "nullable": false,

292 "type": {294 "type": {

293 "kind": "HttpTypeObject",295 "kind": "HttpTypeObject",

294 "members": [296 "members": [


309 }311 }

310 ]312 ]

311 },313 },

312 "oasRef": "#/components/schemas/CreateChatCompletionStreamResponse/properties/choices/items/properties/delta",314 "optional": false,

313 "deprecated": false,315 "nullable": false,

314 "schemaType": "object",316 "schemaType": "object",

315 "childrenParentSchema": "object",317 "childrenParentSchema": "object",

316 "children": [318 "children": [


323 },325 },

324 "(resource) chat.completions > (model) chat_completion_chunk > (schema) > (property) choices > (items) > (property) finish_reason": {326 "(resource) chat.completions > (model) chat_completion_chunk > (schema) > (property) choices > (items) > (property) finish_reason": {

325 "kind": "HttpDeclProperty",327 "kind": "HttpDeclProperty",

326 "docstring": "The reason the model stopped generating tokens. This will be `stop` if the model hit a natural stop point or a provided stop sequence,\n`length` if the maximum number of tokens specified in the request was reached,\n`content_filter` if content was omitted due to a flag from our content filters,\n`tool_calls` if the model called a tool, or `function_call` (deprecated) if the model called a function.\n",328 "oasRef": "#/components/schemas/CreateChatCompletionStreamResponse/properties/choices/items/properties/finish_reason",

329 "deprecated": false,

327 "key": "finish_reason",330 "key": "finish_reason",

328 "optional": false,331 "docstring": "The reason the model stopped generating tokens. This will be `stop` if the model hit a natural stop point or a provided stop sequence,\n`length` if the maximum number of tokens specified in the request was reached,\n`content_filter` if content was omitted due to a flag from our content filters,\n`tool_calls` if the model called a tool, or `function_call` (deprecated) if the model called a function.\n",

329 "nullable": true,

330 "type": {332 "type": {

331 "kind": "HttpTypeUnion",333 "kind": "HttpTypeUnion",

334 "oasRef": "#/components/schemas/CreateChatCompletionStreamResponse/properties/choices/items/properties/finish_reason",

332 "types": [335 "types": [

333 {336 {

334 "kind": "HttpTypeLiteral",337 "kind": "HttpTypeLiteral",


350 "kind": "HttpTypeLiteral",353 "kind": "HttpTypeLiteral",

351 "literal": "function_call"354 "literal": "function_call"

352 }355 }

353 ],356 ]

354 "oasRef": "#/components/schemas/CreateChatCompletionStreamResponse/properties/choices/items/properties/finish_reason"

355 },357 },

356 "oasRef": "#/components/schemas/CreateChatCompletionStreamResponse/properties/choices/items/properties/finish_reason",358 "optional": false,

357 "deprecated": false,359 "nullable": true,

358 "schemaType": "enum",360 "schemaType": "enum",

359 "childrenParentSchema": "enum",361 "childrenParentSchema": "enum",

360 "children": [362 "children": [


367 },369 },

368 "(resource) chat.completions > (model) chat_completion_chunk > (schema) > (property) choices > (items) > (property) index": {370 "(resource) chat.completions > (model) chat_completion_chunk > (schema) > (property) choices > (items) > (property) index": {

369 "kind": "HttpDeclProperty",371 "kind": "HttpDeclProperty",

370 "docstring": "The index of the choice in the list of choices.",372 "oasRef": "#/components/schemas/CreateChatCompletionStreamResponse/properties/choices/items/properties/index",

373 "deprecated": false,

371 "key": "index",374 "key": "index",

372 "optional": false,375 "docstring": "The index of the choice in the list of choices.",

373 "nullable": false,

374 "type": {376 "type": {

375 "kind": "HttpTypeNumber"377 "kind": "HttpTypeNumber"

376 },378 },

377 "oasRef": "#/components/schemas/CreateChatCompletionStreamResponse/properties/choices/items/properties/index",379 "optional": false,

378 "deprecated": false,380 "nullable": false,

379 "schemaType": "integer",381 "schemaType": "integer",

380 "children": []382 "children": []

381 },383 },

382 "(resource) chat.completions > (model) chat_completion_chunk > (schema) > (property) choices > (items) > (property) logprobs": {384 "(resource) chat.completions > (model) chat_completion_chunk > (schema) > (property) choices > (items) > (property) logprobs": {

383 "kind": "HttpDeclProperty",385 "kind": "HttpDeclProperty",

384 "docstring": "Log probability information for the choice.",386 "oasRef": "#/components/schemas/CreateChatCompletionStreamResponse/properties/choices/items/properties/logprobs",

387 "deprecated": false,

385 "key": "logprobs",388 "key": "logprobs",

386 "optional": true,389 "docstring": "Log probability information for the choice.",

387 "nullable": true,

388 "type": {390 "type": {

389 "kind": "HttpTypeObject",391 "kind": "HttpTypeObject",

390 "members": [392 "members": [


396 }398 }

397 ]399 ]

398 },400 },

399 "oasRef": "#/components/schemas/CreateChatCompletionStreamResponse/properties/choices/items/properties/logprobs",401 "optional": true,

400 "deprecated": false,402 "nullable": true,

401 "schemaType": "object",403 "schemaType": "object",

402 "childrenParentSchema": "object",404 "childrenParentSchema": "object",

403 "children": [405 "children": [


414 },416 },

415 "(resource) chat.completions > (model) chat_completion_chunk > (schema) > (property) moderation > (property) input": {417 "(resource) chat.completions > (model) chat_completion_chunk > (schema) > (property) moderation > (property) input": {

416 "kind": "HttpDeclProperty",418 "kind": "HttpDeclProperty",

417 "docstring": "Moderation for the request input.",419 "oasRef": "#/components/schemas/ChatCompletionModeration/properties/input",

420 "deprecated": false,

418 "key": "input",421 "key": "input",

419 "optional": false,422 "docstring": "Moderation for the request input.",

420 "nullable": false,

421 "type": {423 "type": {

422 "kind": "HttpTypeUnion",424 "kind": "HttpTypeUnion",

425 "oasRef": "#/components/schemas/ChatCompletionModeration/properties/input",

423 "types": [426 "types": [

424 {427 {

425 "kind": "HttpTypeObject",428 "kind": "HttpTypeObject",


449 }452 }

450 ]453 ]

451 }454 }

452 ],455 ]

453 "oasRef": "#/components/schemas/ChatCompletionModeration/properties/input"

454 },456 },

455 "oasRef": "#/components/schemas/ChatCompletionModeration/properties/input",457 "optional": false,

456 "deprecated": false,458 "nullable": false,

457 "schemaType": "union",459 "schemaType": "union",

458 "childrenParentSchema": "union",460 "childrenParentSchema": "union",

459 "children": [461 "children": [


463 },465 },

464 "(resource) chat.completions > (model) chat_completion_chunk > (schema) > (property) moderation > (property) output": {466 "(resource) chat.completions > (model) chat_completion_chunk > (schema) > (property) moderation > (property) output": {

[...]
